<?php 

if ( ! function_exists( 'gp_carousel' ) ) {
	function gp_carousel($atts, $content = null) {
		extract(shortcode_atts(array(
			'header' => '',
			'rss' => '',
			'color' => '',    
			'post_type' => 'post',
			'cats' => '',
			'ids' => '',
			'width' => '1110',
			'height' => '',
			'images' => 'true',
			'image_width' => '198',
			'image_height' => '118',
			'image_wrap' => 'false',
			'hard_crop' => 'true',
			'per_page' => '30',
			'offset' => '0',
			'link' => 'both',        
			'min_visible' => '3',
			'max_visible' => '5',
			'auto' => 'false',
			'speed' => '500',
			'circular' => 'false',
			'swipe' => 'true',
			'buttons' => 'true',        
			'orderby' => 'date',
			'order' => 'desc',
			'content_display' => 'excerpt',
			'excerpt_length' => '0',
			'read_more' => 'true',
			'title' => 'true',
			'title_size' => '',
			'title_font' => '',        
			'title_length' => '40',
			'excerpt_length' => '0',        
			'meta' => 'false',
			'meta_author' => 'true',
			'meta_date' => 'true',
			'meta_cats' => 'true',
			'meta_tags' => 'true',
			'score' => 'true',
			'classes' => ''                 
		), $atts));

		require(gp_inc . 'options.php'); global $dirname, $gp_settings;
	
	
		// Unique Name
	
		STATIC $i = 0;
		$i++;
		$name = 'carousel'.$i;


		// Fix for deprecated content variables v1.7
	
		if(isset($atts['content'])) { $post_type = $atts['content']; }
		if(isset($atts['posts'])) { $per_page = $atts['posts']; }
	
	
		// Load Scripts
	
		if($i == 1) {	
			wp_enqueue_script('gp-carousel');
			wp_enqueue_script('gp-touchswipe');
		}
		
		
		// Categories
	
		if($cats) { 
			$slide_cats = array('taxonomy' => 'slide_categories', 'terms' => explode(',', $cats), 'field' => 'slug');
			$post_cats = array('taxonomy' => 'category', 'terms' => explode(',', $cats), 'field' => 'slug');
		} else {
			$slide_cats = null;
			$post_cats = null;
		}
	

		// IDs
	
		if($ids) { 
			$ids = explode(',', $ids);
		} else {
			$ids = null;
		}
		
	
		// Order By
	
		if($orderby == 'score') { 
			$orderby = 'meta_value_num';
			$meta_key = '_'.$dirname.'_total_score';
		} else {
			$orderby = $orderby;
			$meta_key = '';
		}
	
	
		// Title Size
	
		$title_weight = '';
		if($title_size != "") {
			if(preg_match('/^1[0-4]$/', $title_size)) {
				$title_weight = 'font-weight: bold; ';				
			}
		}
		if($title_size != "") {
			if(preg_match('/%/', $title_size) OR preg_match('/em/', $title_size) OR preg_match('/px/', $title_size)) {
				$title_size = 'font-size: '.$title_size.'; ';				
			} else {
				$title_size = 'font-size: '.$title_size.'px; ';		
			}
		} else {
			$title_size = "";
		}
	
	
		// Title Font
	
		if($title_font != "") {
			$title_font = 'font-family: '.$title_font.'; ';		
		} else {
			$title_font = "";
		}
	
		
		// Post Query
	
		$args=array(
		'post_type' => explode(',', $post_type),
		'tax_query' => array('relation' => 'OR', $slide_cats, $post_cats),
		'post__in' => $ids,
		'ignore_sticky_posts' => 0,
		'orderby' => $orderby,
		'order' => $order,
		'meta_key' => $meta_key,
		'paged' => 1,	
		'posts_per_page' => $per_page,
		'offset' => $offset	
		);
	
		$featured_query = new wp_query($args);
	
		ob_start(); ?>
	
	
		<?php if ($featured_query->have_posts()) : ?>
	
	
			<!-- BEGIN CAROUSEL WRAPPER -->
		
			<div class="carousel-wrapper carousel <?php echo $classes; ?>">
		
			
				<!-- BEGIN HEADER -->
			
				<?php if($header) { ?><h3 class="featured-header" style="border-color: <?php echo $color; ?>;"><?php echo $header; ?><?php if($rss) { ?><a href="<?php echo $rss; ?>" class="fa fa-rss"></a><?php } ?></h3><?php } ?>
			
				<!-- END HEADER -->
			
			
				<!-- BEGIN BUTTONS -->
			
				<?php if($buttons == "true") { ?>							
					<span class="carousel-nav<?php if($header) { ?> carousel-nav-header<?php } ?>">
						<a id="<?php echo $name; ?>-carousel-prev" class="fa fa-caret-left"></a>
						<a id="<?php echo $name; ?>-carousel-next" class="fa fa-caret-right"></a>
					</span>
				<?php } ?>
			
				<!-- END BUTTONS -->
			
					
				<!-- BEGIN CAROUSEL -->	
				
				<div id="<?php echo $name; ?>">

					<?php while ($featured_query->have_posts()) : $featured_query->the_post();
				
		
					// Star Number

					if(get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true) && get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true) != 'Default') {
						$gp_settings['star_number'] = get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true);
					} else {
						$gp_settings['star_number'] = get_option($dirname.'_star_number');
					}
			
						
					// Total Score
				
					if(get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) > 0) {
						$total_score_width = (get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) / $gp_settings['star_number']) * 100;
					} else {
						$total_score_width = 0;
					}
					
					?>
	
					
						<!-- BEGIN POST -->
					
						<div <?php post_class('post-loop'); ?>>
						
						
							<!-- BEGIN FEATURED IMAGE -->
						
							<?php if(has_post_thumbnail() && $images == "true") { ?>
								
								<div class="post-thumbnail<?php if($image_wrap == "true") { ?> wrap<?php } ?>">

									<?php if(($link == "image" OR $link == "both") && get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) != "None") { ?>
										<a href="<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox") { if(get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true)) { echo get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true); } else { echo wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())); }} else { if(get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true)) { echo get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true); } else { the_permalink(); }} ?>"<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox") { ?> class="prettyphoto" rel="prettyPhoto[<?php echo $name; the_ID(); ?>]"<?php } ?>>
									<?php } ?>

										<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox") { ?>
											<span class="lightbox-hover fa fa-plus"></span>
										<?php } ?>
																																
										<?php $image = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $image_width, $image_height, $hard_crop, false, true); ?>
										<?php if(get_option($dirname.'_retina') == "0") { $retina = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $image_width*2, $image_height*2, $hard_crop, true, true); } else { $retina = ""; } ?>
										<img src="<?php echo $image[0]; ?>" data-rel="<?php echo $retina; ?>" width="<?php echo $image[1]; ?>" height="<?php echo $image[2]; ?>" alt="<?php if(get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true)) { echo get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true); } else { echo the_title_attribute(); } ?>" class="wp-post-image" />	
														
									<?php if(($link == "image" OR $link == "both") && get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) != "None") { ?></a><?php } ?>
						
								</div>
									
								<?php if($image_wrap == "false") { ?><div class="clear"></div><?php } ?>
				
							<?php } ?>
						
							<!-- END FEATURED IMAGE -->
						
						
							<!-- BEGIN LIGHTBOX IMAGES -->
				
							<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox Image" OR get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox Video") { ?>
				
								<?php $args = array('post_type' => 'attachment', 'post_parent' => get_the_ID(), 'numberposts' => -1, 'orderby' => 'menu_order', 'order' => 'asc', 'post__not_in'	=> array(get_post_thumbnail_id())); $attachments = get_children($args); if($attachments) { foreach ($attachments as $attachment) { ?>
				
									<a href="<?php if(get_post_meta($attachment->ID, '_'.$dirname.'_lightbox_url', true)) { echo get_post_meta($attachment->ID, '_'.$dirname.'_lightbox_url', true); } else { echo wp_get_attachment_url($attachment->ID); } ?>" class="prettyphoto" rel="prettyPhoto[<?php echo $name; the_ID(); ?>]" title="<?php echo $attachment->post_content; ?>" style="display: none;"><img src="" alt="<?php echo $attachment->post_title; ?>"></a>
				
								<?php }} ?>

							<?php } ?>
										
							<!-- END LIGHTBOX IMAGES -->
												
						
							<!-- BEGIN POST TEXT -->
						
							<div class="post-text">
						
							
								<!-- BEGIN TITLE -->
								
								<?php if($title == "true") { ?><h2 class="entry-title" style="<?php echo $title_size.$title_font.$title_weight; ?>"><?php if($link == "title" OR $link == "both") { ?><a href="<?php the_permalink(); ?>" title="<?php the_title_attribute(); ?>"><?php } ?><?php echo gp_the_title_limit($title_length); ?><?php if($link == "title" OR $link == "both") { ?></a><?php } ?></h2><?php } ?>
		
								<!-- END TITLE -->
							
	
								<!-- BEGIN SCORE META -->
							
								<?php if($score == "true" && get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) > 0) { ?>
							
									<div class="score-meta">	
					
										<span class="gp-stars-wrapper" style="width: <?php echo (19.6 * $gp_settings['star_number']); ?>px;"><span class="rating-unselected"><span class="rating-selection" style="width:<?php echo $total_score_width; ?>%"></span></span></span>
									</div>	
							
								<?php } ?>
														
								<!-- END SCORE META -->
													
							
								<!-- BEGIN POST META-->
							
								<?php if($meta == "true" && ($meta_date == "true" OR $meta_author == "true" OR $meta_cats == "true")) { ?>
							
									<div class="post-meta">
								
										<div class="meta-details">
									
											<div class="meta-details">

												<?php if($meta_author == "true") { ?><span class="meta-author"><?php the_author_posts_link(); ?></span><?php } ?>
										
												<?php if($meta_date == "true") { ?><span class="meta-date"><?php the_time(get_option('date_format')); ?></span><?php } ?>
										
												<?php if($meta_cats == "true") { ?><span class="meta-cats"><?php the_category(', '); ?></span><?php } ?>
										
											</div>
																				
										</div>
									
									</div>
								
								<?php } ?>
							
								<!-- END POST META-->
										
							
								<!-- BEGIN POST CONTENT -->
												
								<?php if($content_display == "full") { ?>	
					
									<?php global $more; $more = 0; the_content('&raquo;'); ?>
							
								<?php } else { ?>
					
									<?php if($excerpt_length != "0") { ?><p><?php echo gp_excerpt($excerpt_length); ?><?php if($read_more == "true") { ?> <a href="<?php the_permalink(); ?>" class="read-more" title="<?php the_title_attribute(); ?>"> &raquo;</a><?php } ?></p><?php } ?>
						
								<?php } ?>
					
								<!-- END POST CONTENT -->
							
																					
								<!-- BEGIN POST TAGS -->
			
								<?php if($meta == "true" && $meta_tags == "true") { ?>
									<?php the_tags('<div class="meta-tags"><span>'.__('Tags', 'gp_lang').':</span>', '', '</div>'); ?>
								<?php } ?>
			
								<!-- END POST TAGS -->
												
																					
							</div>	
						
							<!-- END POST TEXT -->					
					
					
						</div>	
					
						<!-- END POST -->
						
					
					<?php endwhile; wp_reset_query(); ?>

		
				</div>
				
				<!-- END CAROUSEL -->
		
		
			</div>
		
			<!-- END CAROUSEL WRAPPER -->
		
		
		<?php endif; ?>
		
		
		<script>
		jQuery(window).load(function(){
	
			"use strict";

			jQuery('.carousel-wrapper #<?php echo $name; ?> .post-loop').show();
		
			jQuery('#<?php echo $name; ?>').swipe({
				excludedElements: 'button, input, select, textarea, .noSwipe'
			});
			
			jQuery("#<?php echo $name; ?>").carouFredSel({
				responsive: true,
				circular: <?php if($circular == "true") { ?>true<?php } else { ?>false<?php } ?>,
				infinite: true,
				<?php if($swipe == "true") { ?>swipe: true,<?php } ?>
				width: <?php if($width) { echo $width; } else { ?>"variable"<?php } ?>,
				height: <?php if($height) { echo $height; } else { ?>"variable"<?php } ?>,
				align: "left",
				prev: "#<?php echo $name; ?>-carousel-prev",
				next: "#<?php echo $name; ?>-carousel-next",			
				items: {
					visible: {
						min: <?php echo $min_visible; ?>,
						max: <?php echo $max_visible; ?>
					},
					width: <?php echo $image_width; ?>,
					height: "variable"
				},
				auto: <?php if($auto == "true") { ?>true<?php } else { ?>false<?php } ?>,	
				scroll: {
					duration: <?php echo $speed; ?>
				}
			});
	
		});
		</script>
	
	
	<?php

		wp_reset_query();
		$output_string = ob_get_contents();
		ob_end_clean(); 
	
		return $output_string;

	}
}
add_shortcode('carousel', 'gp_carousel');

?>