<?php
	
if ( ! function_exists( 'gp_posts' ) ) {
	function gp_posts($atts, $content = null) {
		extract(shortcode_atts(array(
			'header' => '',
			'header_link' => '',
			'rss' => '',
			'color' => '',	
			'post_type' => 'post',
			'cats' => '',
			'ids' => '',
			'images' => 'true',
			'image_width' => '533',
			'image_height' => '200',
			'image_wrap' => 'false',
			'hard_crop' => 'true',
			'cols' => '2',
			'per_page' => '6',
			'offset' => '0',
			'link' => 'both',
			'pages' => 'true',
			'orderby' => 'date',
			'order' => 'desc',
			'content_display' => 'excerpt',
			'excerpt_length' => '400',
			'read_more' => 'true',
			'title' => 'true',
			'title_size' => '',
			'title_font' => '',
			'title_length' => '500',
			'meta' => 'true',
			'meta_author' => 'true',
			'meta_date' => 'true',
			'meta_cats' => 'true',
			'meta_tags' => 'true',
			'score' => 'true',
			'spacing' => 'spacing-normal',
			'classes' => ''		
		),$atts));

		require(gp_inc . 'options.php'); global $dirname, $gp_settings;


		// Unique Name
	
		STATIC $i = 0;
		$i++;
		$name = 'gridposts'.$i;


		// Fix for deprecated content variables v1.7
	
		if(isset($atts['content'])) { $post_type = $atts['content']; }
		if(isset($atts['pagination'])) { $pages = $atts['pagination']; }

	
		// IDs
	
		if($ids) { 
			$ids = explode(',', $ids);
		} else {
			$ids = null;
		}
		
		
		// Order By
	
		if($orderby == 'score') { 
			$orderby = 'meta_value_num';
			$meta_key = '_'.$dirname.'_total_score';
		} else {
			$orderby = $orderby;
			$meta_key = '';
		}
	
	
		// Title Size
	
		$title_weight = '';
		if($title_size != "") {
			if(preg_match('/^1[0-4]$/', $title_size)) {
				$title_weight = 'font-weight: bold; ';				
			}
		}
		if($title_size != "") {
			if(preg_match('/%/', $title_size) OR preg_match('/em/', $title_size) OR preg_match('/px/', $title_size)) {
				$title_size = 'font-size: '.$title_size.'; ';				
			} else {
				$title_size = 'font-size: '.$title_size.'px; ';		
			}
		} else {
			$title_size = "";
		}
	
	
		// Title Font
	
		if($title_font != "") {
			$title_font = 'font-family: '.$title_font.'; ';		
		} else {
			$title_font = "";
		}
	
	
		// Pagination	
	
		if ( get_query_var( 'paged' ) && $pages == 'true' ) {
			$paged = get_query_var( 'paged' );
		} elseif ( get_query_var( 'page' ) && $pages == 'true' ) {
			$paged = get_query_var( 'page' );
		} else {
			$paged = 1;
		}
	
	
		// Post Query	
	
		$args=array(
		'post_type' => explode(',', $post_type),
		'category_name' => $cats,
		'post__in' => $ids,
		'ignore_sticky_posts' => 0,
		'orderby' => $orderby,
		'order' => $order,
		'meta_key' => $meta_key,
		'paged' => $paged,	
		'posts_per_page' => $per_page,
		'offset' => $offset
		);

		$featured_query = new wp_query($args); $counter = "";
	
		ob_start(); ?>
	
	
		<!-- BEGIN HEADER -->
	
		<?php if($header) { ?><h3 class="featured-header" style="border-color: <?php echo $color; ?>;"><?php if($header_link) { ?><a href="<?php echo $header_link; ?>"><?php } ?><?php echo $header; ?><?php if($header_link) { ?></a><?php } ?><?php if($rss) { ?><a href="<?php echo $rss; ?>" class="fa fa-rss"></a><?php } ?></h3><?php } ?>
	
		<!-- END HEADER -->
		
			
		<!-- BEGIN POST WRAPPER -->
	
		<div class="post-wrapper <?php echo $spacing; ?> <?php echo $classes; ?>">
		
		
			<?php while ($featured_query->have_posts()) : $featured_query->the_post(); $counter = $counter + 1;
		
		
			// Image Dimensions
		
			if(get_post_meta(get_the_ID(), '_'.$dirname.'_thumbnail_width', true) && get_post_meta(get_the_ID(), '_'.$dirname.'_thumbnail_width', true)) {
				$thumbnail_width = get_post_meta(get_the_ID(), '_'.$dirname.'_thumbnail_width', true);
			} else {
				$thumbnail_width = $image_width;
			}
			if(get_post_meta(get_the_ID(), '_'.$dirname.'_thumbnail_height', true) != "") {
				$thumbnail_height = get_post_meta(get_the_ID(), '_'.$dirname.'_thumbnail_height', true);
			} else {
				$thumbnail_height = $image_height;
			}
		
		
			// Columns
		
			if($counter %$cols == 1) {
				$first_column = " first-column ";
			} else {
				$first_column = "";
			}
	
			if($cols > 1) {
				$columns = " post-columns ";
			} else {
				$columns = "";
			}
		
			$col_width = (100 - (($cols -1) * 4)) / $cols;


			// Star Number

			if(get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true) && get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true) != 'Default') {
				$gp_settings['star_number'] = get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true);
			} else {
				$gp_settings['star_number'] = get_option($dirname.'_star_number');
			}

			
			// Total Score
		
			if(get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) > 0) {
				$total_score_width = (get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) / $gp_settings['star_number']) * 100;
			} else {
				$total_score_width = 0;
			}
				
			?>
	
			
				<!-- BEGIN POST -->
			
				<div <?php post_class('post-loop'.$first_column.$columns); ?> style="width: <?php echo $col_width; ?>%;">
						
						
					<!-- BEGIN FEATURED IMAGE -->
				
					<?php if(has_post_thumbnail() && $images == "true") { ?>
								
						<div class="post-thumbnail<?php if($image_wrap == "true") { ?> wrap<?php } ?>">
				
							<?php if(($link == "image" OR $link == "both") && get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) != "None") { ?>
								<a href="<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox") { if(get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true)) { echo get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true); } else { echo wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())); }} else { if(get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true)) { echo get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true); } else { the_permalink(); }} ?>"<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox") { ?> class="prettyphoto" rel="prettyPhoto[<?php echo $name; the_ID(); ?>]"<?php } ?>>
							<?php } ?>
						
								<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox") { ?>
									<span class="lightbox-hover fa fa-plus"></span>
								<?php } ?>
																									
								<?php $image = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $thumbnail_width, $thumbnail_height, $hard_crop, false, true); ?>
								<?php if(get_option($dirname.'_retina') == "0") { $retina = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $thumbnail_width*2, $thumbnail_height*2, $hard_crop, true, true); } else { $retina = ""; } ?>
								<img src="<?php echo $image[0]; ?>" data-rel="<?php echo $retina; ?>" width="<?php echo $image[1]; ?>" height="<?php echo $image[2]; ?>" alt="<?php if(get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true)) { echo get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true); } else { the_title_attribute(); } ?>" class="wp-post-image" />
						
							<?php if(($link == "image" OR $link == "both") && get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) != "None") { ?></a><?php } ?>
						
						</div>					
									
						<?php if($image_wrap == "false") { ?><div class="clear"></div><?php } ?>
				
					<?php } ?>
				
					<!-- END FEATURED IMAGE -->
				
				
					<!-- BEGIN LIGHTBOX IMAGES -->
				
					<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox Image" OR get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox Video") { ?>
				
						<?php $args = array('post_type' => 'attachment', 'post_parent' => get_the_ID(), 'numberposts' => -1, 'orderby' => 'menu_order', 'order' => 'asc', 'post__not_in'	=> array(get_post_thumbnail_id())); $attachments = get_children($args); if($attachments) { foreach ($attachments as $attachment) { ?>
				
							<a href="<?php if(get_post_meta($attachment->ID, '_'.$dirname.'_lightbox_url', true)) { echo get_post_meta($attachment->ID, '_'.$dirname.'_lightbox_url', true); } else { echo wp_get_attachment_url($attachment->ID); } ?>" class="prettyphoto" rel="prettyPhoto[<?php echo $name; the_ID(); ?>]" title="<?php echo $attachment->post_content; ?>" style="display: none;"><img src="" alt="<?php echo $attachment->post_title; ?>"></a>
				
						<?php }} ?>
				
					<?php } ?>
								
					<!-- END LIGHTBOX IMAGES -->
				
				
					<!-- BEGIN POST TEXT -->
				
					<div class="post-text">
				
				
						<!-- BEGIN TITLE -->
					
						<?php if($title == "true") { ?><h2 class="entry-title" style="<?php echo $title_size.$title_font.$title_weight; ?>"><?php if($link == "title" OR $link == "both") { ?><a href="<?php the_permalink(); ?>" title="<?php the_title_attribute(); ?>"><?php } ?><?php echo gp_the_title_limit($title_length); ?><?php if($link == "title" OR $link == "both") { ?></a><?php } ?></h2><?php } ?>
					
						<!-- END TITLE -->
					

						<!-- BEGIN SCORE META -->
					
						<?php if($score == "true" && get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) > 0) { ?>
					
							<div class="score-meta">	
			
								<span class="gp-stars-wrapper" style="width: <?php echo (19.6 * $gp_settings['star_number']); ?>px;"><span class="rating-unselected"><span class="rating-selection" style="width:<?php echo $total_score_width; ?>%"></span></span></span>
							</div>	
					
						<?php } ?>
												
						<!-- END SCORE META -->
						
												
						<!-- BEGIN POST META-->
					
						<?php if($meta == "true" && ($meta_date == "true" OR $meta_author == "true" OR $meta_cats == "true")) { ?>
					
							<div class="post-meta">
								
								<div class="meta-details">			

									<?php if($meta_author == "true") { ?><span class="meta-author"><?php the_author_posts_link(); ?></span><?php } ?>
								
									<?php if($meta_date == "true") { ?><span class="meta-date"><?php the_time(get_option('date_format')); ?></span><?php } ?>
								
									<?php if($meta_cats == "true") { ?><span class="meta-cats"><?php the_category(', '); ?></span><?php } ?>
								
								</div>
														
							</div>
						
						<?php } ?>
					
						<!-- END POST META-->
					
					
						<!-- BEGIN POST CONTENT -->
					
						<?php if($content_display == "full") { ?>	
					
							<?php global $more; $more = 0; the_content('&raquo;'); ?>
						
						<?php } else { ?>
					
							<?php if($excerpt_length != "0") { ?><p><?php echo gp_excerpt($excerpt_length); ?><?php if($read_more == "true") { ?> <a href="<?php the_permalink(); ?>" class="read-more" title="<?php the_title_attribute(); ?>"> &raquo;</a><?php } ?></p><?php } ?>
						
						<?php } ?>
					
						<!-- END POST CONTENT -->
	
					
						<!-- BEGIN POST TAGS -->
					
						<?php if($meta == "true" && $meta_tags == "true") { ?>
							<?php the_tags('<div class="meta-tags"><span>'.__('Tags', 'gp_lang').':</span>', '', '</div>'); ?>
						<?php } ?>
					
						<!-- END POST TAGS -->
					
					
					</div>
				
					<!-- END POST TEXT -->
				
	
				</div>
			
				<!-- END POST -->
			
				
				<?php if($cols > 1 && $counter %$cols == 0) { ?><div class="clear"></div><?php } ?>
			
			
			<?php endwhile; ?>
		
		
			<?php if($pages == "true") { ?>
				<?php gp_pagination($featured_query->max_num_pages); ?>
				<div class="clear"></div>
			<?php } ?>
		

		</div>
	
		<!-- END POST WRAPPER -->
	

	<?php
	
		wp_reset_query();
		$output_string = ob_get_contents();
		ob_end_clean(); 
	
		return $output_string;

	}
}
add_shortcode("posts", "gp_posts");

?>