<?php

if ( ! function_exists( 'gp_related_posts' ) ) {
	function gp_related_posts($atts, $content = null) {
		extract(shortcode_atts(array(
			'header' => 'Related Posts',
			'post_type' => 'post',
			'cats' => '',
			'ids' => '',	
			'width' => '1110',
			'height' => '',		
			'images' => 'true',
			'image_width' => '252',
			'image_height' => '150',
			'image_wrap' => 'false',
			'hard_crop' => 'true',
			'per_page' => '30',
			'offset' => '0',
			'link' => 'both', 
			'min_visible' => '3',
			'max_visible' => '5',       		
			'auto' => 'false',
			'circular' => 'false',
			'speed' => '500',	
			'swipe' => 'true',
			'buttons' => 'true',        	
			'orderby' => 'rand',
			'order' => 'desc',
			'content_display' => 'excerpt',
			'excerpt_length' => '0',
			'read_more' => 'true',		
			'title' => 'true',
			'title_length' => '40',		
			'meta' => 'false',
			'meta_author' => 'true',
			'meta_date' => 'true',
			'meta_cats' => 'true',
			'meta_tags' => 'true',
			'score' => 'true',
			'classes' => ''
		), $atts));

		require(gp_inc . 'options.php'); global $dirname, $gp_settings, $wp_query;


		// Unique Name
	
		STATIC $i = 0;
		$i++;
		$name = 'relatedposts'.$i;


		// Fix for deprecated content variables v1.7

		if(isset($atts['content'])) { $post_type = $atts['content']; }
		if(isset($atts['posts'])) { $per_page = $atts['posts']; }
		if(isset($atts['id'])) { $ids = $atts['id']; }


		// Load Scripts
	
		if($i == 1) {
			wp_enqueue_script('gp-carousel');
			wp_enqueue_script('gp-touchswipe');
		}
		
		
		// Post IDs
	
		if($ids == '') {
			$ids = get_the_ID();
		} else {
			$ids;
		}


		// Order By
	
		if($orderby == 'score') { 
			$orderby = 'meta_value_num';
			$meta_key = '_'.$dirname.'_total_score';
		} else {
			$orderby = $orderby;
			$meta_key = '';
		}
		
	
		// Post Query
	
		$tags = wp_get_post_tags($ids);
		$tempQuery = $wp_query;
	
		if($tags) {
		$tag_ids = array();
	
		foreach($tags as $individual_tag) $tag_ids[] = $individual_tag->term_id;
	
		$args=array(
		'post_type' => explode(',', $post_type),
		'category_name' => $cats,
		'ignore_sticky_posts' => 0,
		'orderby' => $orderby,
		'order' => $order,
		'meta_key' => $meta_key,
		'paged' => 1,
		'posts_per_page' => $per_page,
		'offset' => $offset,
		'tag__in' => $tag_ids,
		'post__not_in' => array($ids)
		);
	
		$featured_query = new wp_query($args);  if ( $featured_query->have_posts() ) :
	
		ob_start(); ?>
	
	
		<!-- BEGIN CAROUSEL WRAPPER -->
		
		<div class="carousel-wrapper related-posts <?php echo $classes; ?>">
		
		
			<!-- BEGIN HEADER -->
		
			<?php if($header) { ?><h3><?php echo $header; ?></h3><?php } ?>
		
			<!-- END HEADER -->
		
		
			<!-- BEGIN BUTTONS -->
		
			<?php if($buttons == "true") { ?>							
				<span class="carousel-nav<?php if($header) { ?> carousel-nav-header<?php } ?>">
					<a id="<?php echo $name; ?>-carousel-prev" class="fa fa-caret-left"></a>
					<a id="<?php echo $name; ?>-carousel-next" class="fa fa-caret-right"></a>
				</span>
			<?php } ?>
		
			<!-- END BUTTONS-->
		
		
			<!-- BEGIN CAROUSEL -->
					
			<div id="<?php echo $name; ?>">
			
			
				<?php while ($featured_query->have_posts()) : $featured_query->the_post(); 
				
				
				// Star Number

				if(get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true) && get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true) != 'Default') {
					$gp_settings['star_number'] = get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true);
				} else {
					$gp_settings['star_number'] = get_option($dirname.'_star_number');
				}
			
						
				// Total Score
			
				if(get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) > 0) {
					$total_score_width = (get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) / $gp_settings['star_number']) * 100;
				} else {
					$total_score_width = 0;
				}
		
				?>
	
				
					<!-- BEGIN POST -->
				
					<div <?php post_class('post-loop'); ?>>
						
							
						<!-- BEGIN FEATURED IMAGE -->
					
						<?php if(has_post_thumbnail() && $images == "true") { ?>				
							
							<div class="post-thumbnail<?php if($image_wrap == "true") { ?> wrap<?php } ?>">

								<?php if(($link == "image" OR $link == "both") && get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) != "None") { ?>
									<a href="<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox") { if(get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true)) { echo get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true); } else { echo wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())); }} else { if(get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true)) { echo get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true); } else { the_permalink(); }} ?>"<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox") { ?> class="prettyphoto" rel="prettyPhoto[<?php echo $name; the_ID(); ?>]"<?php } ?>>
								<?php } ?>

									<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox") { ?>
										<span class="lightbox-hover fa fa-plus"></span>
									<?php } ?>
																															
									<?php $image = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $image_width, $image_height, $hard_crop, false, true); ?>
									<?php if(get_option($dirname.'_retina') == "0") { $retina = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $image_width*2, $image_height*2, $hard_crop, true, true); } else { $retina = ""; } ?>
									<img src="<?php echo $image[0]; ?>" data-rel="<?php echo $retina; ?>" width="<?php echo $image[1]; ?>" height="<?php echo $image[2]; ?>" alt="<?php if(get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true)) { echo get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true); } else { the_title_attribute(); } ?>" class="wp-post-image" />	
					
								<?php if(($link == "image" OR $link == "both") && get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) != "None") { ?></a><?php } ?>
					
							</div>				
								
							<?php if($image_wrap == "false") { ?><div class="clear"></div><?php } ?>
			
						<?php } ?>
					
						<!-- END FEATURED IMAGE -->
					
					
						<!-- BEGIN LIGHTBOX IMAGES -->
			
						<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox Image" OR get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox Video") { ?>
					
							<?php $args = array('post_type' => 'attachment', 'post_parent' => get_the_ID(), 'numberposts' => -1, 'orderby' => 'menu_order', 'order' => 'asc', 'post__not_in'	=> array(get_post_thumbnail_id())); $attachments = get_children($args); if($attachments) { foreach ($attachments as $attachment) { ?>
			
								<a href="<?php if(get_post_meta($attachment->ID, '_gp_video_url', true)) { echo get_post_meta($attachment->ID, '_gp_video_url', true); } else { echo wp_get_attachment_url($attachment->ID); } ?>" class="prettyphoto" rel="prettyPhoto[<?php echo $name; the_ID(); ?>]" title="<?php echo $attachment->post_content; ?>" style="display: none;"><img src="" alt="<?php echo $attachment->post_title; ?>"></a>
			
							<?php }} ?>
					
						<?php } ?>
								
						<!-- END LIGHTBOX IMAGES -->
					
					
						<!-- BEGIN POST TEXT -->
					
						<div class="post-text<?php if($image_wrap == "true") { ?> no-left<?php } ?>">
					
					
							<!-- BEGIN TITLE -->
						
							<?php if($title == "true") { ?><h2 class="entry-title"><a href="<?php the_permalink(); ?>" title="<?php the_title_attribute(); ?>"><?php echo gp_the_title_limit($title_length); ?></a></h2><?php } ?>
						
							<!-- END TITLE -->
						
		
							<!-- BEGIN SCORE META -->
						
							<?php if($score == "true" && get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) > 0) { ?>
						
								<div class="score-meta">	
				
									<span class="gp-stars-wrapper" style="width: <?php echo (19.6 * $gp_settings['star_number']); ?>px;"><span class="rating-unselected"><span class="rating-selection" style="width:<?php echo $total_score_width; ?>%"></span></span></span>
								</div>	
						
							<?php } ?>
													
							<!-- END SCORE META -->

					
							<!-- BEGIN POST META-->
						
							<?php if($meta == "true" && ($meta_date == "true" OR $meta_author == "true" OR $meta_cats == "true")) { ?>
						
								<div class="post-meta">
								
									<div class="meta-details">
								
										<?php if($meta_author == "true") { ?><span class="meta-author"><?php the_author_posts_link(); ?></span><?php } ?>
									
										<?php if($meta_date == "true") { ?><span 
										class="meta-date"><?php the_time(get_option('date_format')); ?></span><?php } ?>
									
										<?php if($meta_cats == "true") { ?><span class="meta-cats"><?php the_category(', '); ?></span><?php } ?>
								
									</div>
																
								</div>
							
							<?php } ?>
						
							<!-- END POST META-->
						
						
							<!-- BEGIN POST CONTENT -->
						
							<?php if($content_display == "full") { ?>	
				
								<?php global $more; $more = 0; the_content('&raquo;'); ?>
					
							<?php } else { ?>
				
								<?php if($excerpt_length != "0") { ?><p><?php echo gp_excerpt($excerpt_length); ?><?php if($read_more == "true") { ?> <a href="<?php the_permalink(); ?>" class="read-more" title="<?php the_title_attribute(); ?>"> &raquo;</a><?php } ?></p><?php } ?>
					
							<?php } ?>
						
							<!-- END POST CONTENT -->
						
					
							<!-- BEGIN POST TAGS -->
		
							<?php if($meta == "true" && $meta_tags == "true") { ?>
								<?php the_tags('<div class="meta-tags"><span>'.__('Tags', 'gp_lang').':</span>', '', '</div>'); ?>
							<?php } ?>
		
							<!-- END POST TAGS -->
						
					
						</div>
					
						<!-- END POST TEXT -->
					
		
					</div>
				
					<!-- END POST -->
				
				
				<?php endwhile; ?>


			</div>
		
			<!-- END CAROUSEL -->
		
		
		</div>
	
		<!-- END CAROUSEL WRAPPER -->
	

		<script>
		jQuery(window).load(function(){
			
			"use strict";
			
			jQuery('.carousel-wrapper #<?php echo $name; ?> .post').show();

			jQuery("#<?php echo $name; ?>").carouFredSel({
				responsive: true,
				circular: <?php if($circular == "true") { ?>true<?php } else { ?>false<?php } ?>,
				infinite: true,
				<?php if($swipe == "true") { ?>swipe: true,<?php } ?>
				width: <?php if($width) { echo $width; } else { ?>"variable"<?php } ?>,
				height: <?php if($height) { echo $height; } else { ?>"variable"<?php } ?>,
				align: "left",
				prev: "#<?php echo $name; ?>-carousel-prev",
				next: "#<?php echo $name; ?>-carousel-next",			
				items: {
					visible: {
						min: <?php echo $min_visible; ?>,
						max: <?php echo $max_visible; ?>
					},
					width: <?php echo $image_width; ?>,
					height: "variable"
				},
				auto: <?php if($auto == "true") { ?>true<?php } else { ?>false<?php } ?>,	
				scroll: {
					duration: <?php echo $speed; ?>
				}
			})
		});
		</script>
	
	
	<?php 
		endif;
		wp_reset_query();
		$output_string = ob_get_contents();
		ob_end_clean(); 

		return $output_string;
	
		}

	}
}
add_shortcode("related_posts", "gp_related_posts");

?>