<?php 

if ( ! function_exists( 'gp_slider' ) ) {
	function gp_slider($atts, $content = null) {
		extract(shortcode_atts(array(
			'post_type' => 'slide',
			'cats' => '',
			'ids' => '',
			'width' => '1110',
			'height' => '500',
			'hard_crop' => 'true',
			'per_page' => '-1',
			'offset' => '',
			'effect' => 'fade',
			'timeout' => '6',
			'orderby' => 'menu_order',
			'order' => 'asc',
			'buttons' => 'true',
			'score' => 'true',
			'content_display' => 'excerpt',
			'excerpt_length' => '100',
			'title' => 'true',       
			'title_length' => '40',     
			'margins' => '',
			'align' => 'aligncenter',
			'classes' => ''
		), $atts));

		require(gp_inc . 'options.php'); global $post, $gp_settings, $dirname;
	

		// Unique Name
	
		STATIC $i = 0;
		$i++;
		$name = 'slider'.$i;


		// Fix for deprecated content variables v1.7	
	
		if(isset($atts['content'])) { $post_type = $atts['content']; }
		if(isset($atts['slides'])) { $per_page = $atts['slides']; }
		
		if($post_type == "both") {
			$post_type = "slide,post";
		} elseif($post_type == "posts") {
			$post_type = "post";	
		} elseif($post_type == "slides") {
			$post_type = "slide";
		}	
	
	
		// Load Scripts
	
		if($i == 1) {
			wp_enqueue_script('gp-flexslider');		
			wp_enqueue_script('gp-touchswipe');
		}
		
	
		// Categories
	
		if($cats) { 
			$slide_cats = array('taxonomy' => 'slide_categories', 'terms' => explode(',', $cats), 'field' => 'slug');
			$post_cats = array('taxonomy' => 'category', 'terms' => explode(',', $cats), 'field' => 'slug');
		} else {
			$slide_cats = null;
			$post_cats = null;
		}
	

		// IDs
	
		if($ids) { 
			$ids = explode(',', $ids);
		} else {
			$ids = null;
		}
		
	
		// Margins
	
		if($margins != "") {
			if(preg_match('/%/', $margins) OR preg_match('/em/', $margins) OR preg_match('/px/', $margins)) {
				$margins = str_replace(",", " ", $margins);
				$margins = 'margin: '.$margins.'; ';	
			} else {
				$margins = str_replace(",", "px ", $margins);
				$margins = 'margin: '.$margins.'px; ';		
			}
			$margins = str_replace("autopx", "auto", $margins);
		} else {
			$margins = "";
		}
	
	
		// Slider Query	
	
		$args=array(
		'post_type' => explode(',', $post_type),
		'tax_query' => array('relation' => 'OR', $slide_cats, $post_cats),	
		'post__in' => $ids,
		'ignore_sticky_posts' => 0,
		'orderby' => $orderby,
		'order' => $order,
		'paged' => 1,
		'posts_per_page' => $per_page,
		'offset' => $offset
		);

		$featured_query = new wp_query($args);
	
		ob_start(); ?>
	
		<?php if ($featured_query->have_posts()) : ?>
	
		
			<!-- BEGIN SLIDER WRAPPER -->
		
			<div id="<?php echo $name; ?>" class="flexslider <?php echo $align; ?>" style="width: <?php echo $width; ?>px; <?php echo $margins; ?>">
			
			
				<!-- BEGIN SLIDER -->
			
				<ul class="slides">
	
	
					<?php while ($featured_query->have_posts()) : $featured_query->the_post();			
				

					// Star Number

					if(get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true) && get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true) != 'Default') {
						$gp_settings['star_number'] = get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true);
					} else {
						$gp_settings['star_number'] = get_option($dirname.'_star_number');
					}
			
							
					// Total Score
				
					if(get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) > 0) {
						$total_score_width = (get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) / $gp_settings['star_number']) * 100;
					} else {
						$total_score_width = 0;
					}
							
					?>
	
						<li class="slide" id="<?php echo $name; ?>-slide-<?php the_ID(); ?>">
						
						
							<!-- BEGIN CAPTION -->
						
							<?php if(!get_post_meta(get_the_ID(), '_'.$dirname.'_slide_title', true) OR $post->post_content) { ?>
							
								<div class="caption">
							
							
									<!-- BEGIN SLIDE TITLE -->
								
									<?php if($title == "true") { ?><?php if(!get_post_meta(get_the_ID(), '_'.$dirname.'_slide_title', true)) { ?><h2><?php echo gp_the_title_limit($title_length); ?></h2><?php } ?><?php } ?>
												
									<!-- END SLIDER TITLE -->
								
															
									<!-- BEGIN POST CONTENT -->
								
									<?php if($content_display == "full") { ?>	
								
										<?php global $more; $more = 0; the_content('&raquo;'); ?>
									
									<?php } else { ?>
								
										<?php if($excerpt_length != "0") { ?><p><?php echo gp_excerpt($excerpt_length); ?></p><?php } ?>
									
									<?php } ?>
								
									<!-- END POST CONTENT -->
								
								
									<!-- BEGIN SCORE META -->
								
									<?php if($score == "true" && get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) > 0) { ?>
								
										<div class="score-meta">	
						
											<span class="gp-stars-wrapper" style="width: <?php echo (19.6 * $gp_settings['star_number']); ?>px;"><span class="rating-unselected"><span class="rating-selection" style="width:<?php echo $total_score_width; ?>%"></span></span></span>
										</div>	
								
									<?php } ?>
															
									<!-- END SCORE META -->
							
							
								</div>
						
							<?php } ?>
						
							<!-- END CAPTION -->
	
	
							<!-- BEGIN FEATURED IMAGE -->
							
							<?php if(has_post_thumbnail()) { ?>
						
								<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true) OR get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) != "None") { ?>
								<a href="<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox") { if(get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true)) { echo get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true); } else { echo wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())); }} else { if(get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true)) { echo get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true); } else { the_permalink(); }} ?>" title="<?php the_title_attribute(); ?>"<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox") { ?> class="prettyphoto" rel="prettyPhoto[<?php echo $name; the_ID(); ?>]"<?php } ?>>
								<?php } ?>
								
									<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox") { ?><span class="lightbox-hover fa fa-plus"></span><?php } ?>							
																																																											
									<?php $image = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $width, $height, true, true, true); ?>	
									<?php if(get_option($dirname."_retina") == "0") { $retina = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())),  $width*2, $height*2, true, true, true); } else { $retina = ""; } ?>		
									
									<?php $image = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $width, $height, $hard_crop, false, true); ?>
									<?php if(get_option($dirname.'_retina') == "0") { $retina = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $width*2, $height*2, $hard_crop, true, true); } else { $retina = ""; } ?>
									<img src="<?php echo $image[0]; ?>" data-rel="<?php echo $retina; ?>" width="<?php echo $image[1]; ?>" height="<?php echo $image[2]; ?>" alt="<?php if(get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true)) { echo get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true); } else { the_title_attribute(); } ?>" class="wp-post-image" />
								
								<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_custom_url', true) OR  get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) != "None") { ?></a><?php } ?>	
					
							<?php } ?>
													
							<!-- END FEATURED IMAGE -->
						
	
							<!-- BEGIN LIGHTBOX IMAGES -->
				
							<?php if(get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox Image" OR get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) == "Lightbox Video") { ?>

								<?php $args = array('post_type' => 'attachment', 'post_parent' => get_the_ID(), 'numberposts' => -1, 'orderby' => 'menu_order', 'order' => 'asc', 'post__not_in'	=> array(get_post_thumbnail_id())); $attachments = get_children($args); if($attachments) { foreach ($attachments as $attachment) { ?>
				
									<a href="<?php if(get_post_meta($attachment->ID, '_'.$dirname.'_lightbox_url', true)) { echo get_post_meta($attachment->ID, '_'.$dirname.'_lightbox_url', true); } else { echo wp_get_attachment_url($attachment->ID); } ?>" class="prettyphoto" rel="prettyPhoto[<?php echo $name; the_ID(); ?>]" title="<?php echo $attachment->post_content; ?>" style="display: none;"><img src="" alt="<?php echo $attachment->post_title; ?>"></a>
				
								<?php }} ?>
						
							<?php } ?>
				
							<!-- END LIGHTBOX IMAGES -->
						
							
						</li>
	
					<?php endwhile; ?>
				
			
				</ul>
			
				<!-- END SLIDER -->
			
			
			</div>
		
			<!-- END SLIDER WRAPPER -->

		
		<?php endif; wp_reset_query(); ?>
		
		
		<script>
		jQuery(document).ready(function(){
		
			"use strict";
		
			jQuery("#<?php echo $name; ?>.flexslider").flexslider({ 
				animation: "<?php echo $effect; ?>",
				slideshowSpeed: <?php if($timeout == 0) { echo "9999999"; } else { echo $timeout*1000; } ?>,
				animationSpeed: 600,
				directionNav: false,			
				controlNav: <?php if($buttons == "true") { ?>true<?php } else { ?>false<?php } ?>,				
				pauseOnAction: true, 
				pauseOnHover: false,
				start: function(slider) {

					// Pause Slider
					jQuery("#<?php echo $name; ?> .flex-control-nav li a").click(function() { 
						slider.pause(); 
					});
		
				}
			});
		
		});
		</script>
	
	
	<?php

		$output_string = ob_get_contents();
		ob_end_clean(); 
	
		return $output_string;

	}
}
add_shortcode('slider', 'gp_slider');

?>