<?php

if ( ! function_exists( 'gp_featured_posts' ) ) {
	function gp_featured_posts($atts, $content = null) {
		extract(shortcode_atts(array(
			'type' => 'vertical',
			'header' => '',
			'header_link' => '',
			'rss' => '',
			'color' => '',
			'post_type' => 'post',		
			'cats' => '',
			'ids' => '',
			'large_images' => 'true',
			'small_images' => 'true',		
			'large_image_width' => '533',
			'large_image_height' => '200',
			'small_image_width' => '120',
			'small_image_height' => '120',
			'hard_crop' => 'true',
			'per_page' => '4',
			'offset' => '0',
			'link' => 'both',
			'pages' => 'false',
			'orderby' => 'date',
			'order' => 'desc',
			'large_content_display' => 'excerpt',
			'small_content_display' => 'excerpt',	
			'large_title_length' => '500',
			'small_title_length' => '500',			
			'large_excerpt_length' => '250',
			'small_excerpt_length' => '110',
			'large_title' => 'true',
			'small_title' => 'true',		
			'large_title_size' => '',
			'small_title_size' => '',		
			'large_title_font' => '',
			'small_title_font' => '',		
			'large_meta' => 'true',
			'small_meta' => 'true',		
			'large_meta_author' => 'true',
			'small_meta_author' => 'true',		
			'large_meta_date' => 'true',
			'small_meta_date' => 'true',		
			'large_meta_cats' => 'false',
			'small_meta_cats' => 'false',		
			'large_meta_tags' => 'false',
			'small_meta_tags' => 'false',
			'large_score' => 'true',
			'small_score' => 'true',				
			'large_read_more' => 'false',
			'small_read_more' => 'false',
			'classes' => ''
		),$atts));

		require(gp_inc . 'options.php'); global $wp_query, $dirname, $gp_settings;
	

		// Unique Name
	
		STATIC $i = 0;
		$i++;
		$name = 'vhposts'.$i;


		// Fix for deprecated content variables v1.7
	
		if(isset($atts['content'])) { $post_type = $atts['content']; }
	
		
		// IDs
	
		if($ids) { 
			$ids = explode(',', $ids);
		} else {
			$ids = null;
		}
	
		
		// Order By
	
		if($orderby == 'score') { 
			$orderby = 'meta_value_num';
			$meta_key = '_'.$dirname.'_total_score';
		} else {
			$orderby = $orderby;
			$meta_key = '';
		}


		// Large Title Size
	
		$large_title_weight = '';
		if($large_title_size != "") {
			if(preg_match('/^1[0-4]$/', $large_title_size)) {
				$large_title_weight = 'font-weight: bold; ';				
			}
		}
		if($large_title_size != "") {
			if(preg_match('/%/', $large_title_size) OR preg_match('/em/', $large_title_size) OR preg_match('/px/', $large_title_size)) {
				$large_title_size = 'font-size: '.$large_title_size.'; ';				
			} else {
				$large_title_size = 'font-size: '.$large_title_size.'px; ';		
			}
		} else {
			$large_title_size = "";
		}


		// Small Title Size
	
		$small_title_weight = '';
		if($small_title_size != "") {
			if(preg_match('/^1[0-4]$/', $small_title_size)) {
				$small_title_weight = 'font-weight: bold; ';				
			}
		}
		if($small_title_size != "") {
			if(preg_match('/%/', $small_title_size) OR preg_match('/em/', $small_title_size) OR preg_match('/px/', $small_title_size)) {
				$small_title_size = 'font-size: '.$small_title_size.'; ';				
			} else {
				$small_title_size = 'font-size: '.$small_title_size.'px; ';		
			}
		} else {
			$small_title_size = "";
		}
	
	
		// Large Title Font
	
		if($large_title_font != "") {
			$large_title_font = 'font-family: '.$large_title_font.'; ';		
		} else {
			$large_title_font = "";
		}
			
			
		// Small Title Font
	
		if($small_title_font != "") {
			$small_title_font = 'font-family: '.$small_title_font.'; ';		
		} else {
			$small_title_font = "";
		}
	

		// Pagination	
	
		if ( get_query_var( 'paged' ) && $pages == 'true' ) {
			$paged = get_query_var( 'paged' );
		} elseif ( get_query_var( 'page' ) && $pages == 'true' ) {
			$paged = get_query_var( 'page' );
		} else {
			$paged = 1;
		}
	
		
		// Post Query
		
		$args=array(
		'post_type' => explode(',', $post_type),
		'category_name' => $cats,
		'post__in' => $ids,
		'ignore_sticky_posts' => 0,
		'orderby' => $orderby,
		'order' => $order,
		'meta_key' => $meta_key,
		'paged' => $paged,
		'posts_per_page' => $per_page,
		'offset' => $offset
		);

		$featured_query = new wp_query($args); $counter = "";
	
		ob_start(); ?>
	
			
		<!-- BEGIN HEADER -->
	
		<?php if($header) { ?><h3 class="featured-header" style="border-color: <?php echo $color; ?>;"><?php if($header_link) { ?><a href="<?php echo $header_link; ?>"><?php } ?><?php echo $header; ?><?php if($header_link) { ?></a><?php } ?><?php if($rss) { ?><a href="<?php echo $rss; ?>" class="icon-rss"></a><?php } ?></h3><?php } ?>
	
		<!-- END HEADER -->
		
			
		<!-- BEGIN POST WRAPPER -->
	
		<div class="featured-posts post-wrapper <?php echo $type; ?> <?php echo $classes; ?>">
		
		
			<?php while ($featured_query->have_posts()) : $featured_query->the_post(); $counter = $counter + 1;

	
			// Star Number

			if(get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true) && get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true) != 'Default') {
				$gp_settings['star_number'] = get_post_meta(get_the_ID(), '_'.$dirname.'_star_number', true);
			} else {
				$gp_settings['star_number'] = get_option($dirname.'_star_number');
			}
			
				
			// Total Score
		
			if(get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) > 0) {
				$total_score_width = (get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) / $gp_settings['star_number']) * 100;
			} else {
				$total_score_width = 0;
			}		
									
			?>
	

				<?php if($counter == '1') { ?>

				
					<!-- BEGIN POST -->
				
					<div <?php post_class('post-loop featured-large-post'); ?>>
					
					
						<!-- BEGIN FEATURED IMAGE -->
					
						<?php if(has_post_thumbnail() && $large_images == "true") { ?>				
							<div class="post-thumbnail">															
								<?php if($link == "image" OR $link == "both") { ?><a href="<?php the_permalink(); ?>" title="<?php the_title_attribute(); ?>"><?php } ?>
									<?php $image = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $large_image_width, $large_image_height, $hard_crop, false, true); ?>
									<?php if(get_option($dirname.'_retina') == "0") { $retina = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $large_image_width*2, $large_image_height*2, $hard_crop, true, true); } else { $retina = ""; } ?>
									<img src="<?php echo $image[0]; ?>" data-rel="<?php echo $retina; ?>" width="<?php echo $image[1]; ?>" height="<?php echo $image[2]; ?>" alt="<?php if(get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true)) { echo get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true); } else { the_title_attribute(); } ?>" class="wp-post-image" />						
								<?php if(($link == "image" OR $link == "both") && get_post_meta(get_the_ID(), '_'.$dirname.'_link_type', true) != "None") { ?></a><?php } ?>
							</div>
							<div class="clear"></div>
						<?php } ?>
					
						<!-- END FEATURED IMAGE -->
					
					
						<!-- BEGIN POST TEXT -->
					
						<div class="post-text">
					
						
							<!-- BEGIN TITLE -->
						
							<?php if($large_title == "true") { ?><h2 class="entry-title" style="<?php echo $large_title_size.$large_title_font.$large_title_weight; ?>"><?php if($link == "title" OR $link == "both") { ?><a href="<?php the_permalink(); ?>" title="<?php the_title_attribute(); ?>"><?php } ?><?php echo gp_the_title_limit($large_title_length); ?><?php if($link == "title" OR $link == "both") { ?></a><?php } ?></h2><?php } ?>
						
							<!-- END TITLE -->


							<!-- BEGIN SCORE META -->
						
							<?php if($large_score == "true" && get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) > 0) { ?>
						
								<div class="score-meta">	
				
									<span class="gp-stars-wrapper" style="width: <?php echo (19.6 * $gp_settings['star_number']); ?>px;"><span class="rating-unselected"><span class="rating-selection" style="width:<?php echo $total_score_width; ?>%"></span></span></span>
								</div>	
						
							<?php } ?>
													
							<!-- END SCORE META -->
							
													
							<!-- BEGIN POST META-->
						
							<?php if($large_meta == "true" && ($large_meta_date == "true" OR $large_meta_author == "true" OR $large_meta_cats == "true")) { ?>
						
								<div class="post-meta">
							
										<div class="meta-details">

											<?php if($large_meta_author == "true") { ?><span class="meta-author"><?php the_author_posts_link(); ?></span><?php } ?>
									
											<?php if($large_meta_date == "true") { ?><span class="meta-date"><?php the_time(get_option('date_format')); ?></span><?php } ?>
									
											<?php if($large_meta_cats == "true") { ?><span class="meta-cats"><?php the_category(', '); ?></span><?php } ?>
									
										</div>
																									
								</div>
							
							<?php } ?>
						
							<!-- END POST META-->
								
							
							<!-- BEGIN POST CONTENT -->
											
							<?php if($large_content_display == "full") { ?>	
							
								<?php global $more; $more = 0; the_content('&raquo;'); ?>
							
							<?php } else { ?>
						
								<?php if($large_excerpt_length != "0") { ?><p><?php echo gp_excerpt($large_excerpt_length); ?><?php if($large_read_more == "true") { ?> <a href="<?php the_permalink(); ?>" class="read-more" title="<?php the_title_attribute(); ?>"> &raquo;</a><?php } ?></p><?php } ?>
							
							<?php } ?>
						
							<!-- END POST CONTENT -->
						
						
							<!-- BEGIN POST TAGS -->
							
							<?php if($large_meta == "true" && $large_meta_tags == "true") { ?>
								<?php the_tags('<div class="meta-tags"><span>'.__('Tags', 'gp_lang').':</span>', '', '</div>'); ?>
							<?php } ?>
						
							<!-- END POST TAGS -->
						
																				
						</div>	
					
						<!-- END POST TEXT -->					
				
				
					</div>	
				
					<!-- END POST -->
				
					
					<?php if($type == 'vertical') { ?><div class="clear"></div><?php } ?>
			
			
				<?php } else { ?>	
				
																			
					<?php if($counter == '2') { ?><div class="featured-small-posts"><?php } ?>
					
					
						<!-- BEGIN POST -->	
					
						<div <?php post_class('post-loop featured-small-post'); ?>>
						
						
							<!-- BEGIN FEATURED IMAGE -->
						
							<?php if(has_post_thumbnail() && $small_images == "true") { ?>				
								<div class="post-thumbnail wrap">
									<?php if($link == "image" OR $link == "both") { ?><a href="<?php the_permalink(); ?>" title="<?php the_title_attribute(); ?>"><?php } ?>
										<?php $image = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $small_image_width, $small_image_height, $hard_crop, false, true); ?>
										<?php if(get_option($dirname.'_retina') == "0") { $retina = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $small_image_width*2, $small_image_height*2, $hard_crop, true, true); } else { $retina = ""; } ?>
										<img src="<?php echo $image[0]; ?>" data-rel="<?php echo $retina; ?>" width="<?php echo $image[1]; ?>" height="<?php echo $image[2]; ?>" alt="<?php if(get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true)) { echo get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true); } else { the_title_attribute(); } ?>" class="wp-post-image" />
									<?php if($link == "image" OR $link == "both") { ?></a><?php } ?>
								</div>
							<?php } ?>
				
							<!-- END FEATURED IMAGE -->
						
						
							<!-- BEGIN POST TEXT -->
						
							<div class="post-text">
						
							
								<!-- BEGIN TITLE -->
							
								<?php if($small_title == "true") { ?><h2 class="entry-title" style="<?php echo $small_title_size.$small_title_font.$small_title_weight; ?>"><?php if($link == "title" OR $link == "both") { ?><a href="<?php the_permalink(); ?>" title="<?php the_title_attribute(); ?>"><?php } ?><?php echo gp_the_title_limit($small_title_length); ?><?php if($link == "title" OR $link == "both") { ?></a><?php } ?></h2><?php } ?>
		
								<!-- END TITLE -->
							
	
								<!-- BEGIN SCORE META -->
							
								<?php if($small_score == "true" && get_post_meta(get_the_ID(), '_'.$dirname.'_total_score', true) > 0) { ?>
							
									<div class="score-meta">	
					
										<span class="gp-stars-wrapper" style="width: <?php echo (19.6 * $gp_settings['star_number']); ?>px;"><span class="rating-unselected"><span class="rating-selection" style="width:<?php echo $total_score_width; ?>%"></span></span></span>
									</div>	
							
								<?php } ?>
														
								<!-- END SCORE META -->
							
													
								<!-- BEGIN POST META-->
							
								<?php if($small_meta == "true" && ($small_meta_date == "true" OR $small_meta_author == "true" OR $small_meta_cats == "true")) { ?>
								
									<div class="post-meta">
									
										<div class="meta-details">
									
											<?php if($small_meta_author == "true") { ?><span class="meta-author"><?php the_author_posts_link(); ?></span><?php } ?>
									
											<?php if($small_meta_date == "true") { ?><span class="meta-date"><?php the_time(get_option('date_format')); ?></span><?php } ?>
									
											<?php if($small_meta_cats == "true") { ?><span class="meta-cats"><?php the_category(', '); ?></span><?php } ?>
									
										</div>
																											
									</div>
								
								<?php } ?>
							
								<!-- END POST META-->
							
							
								<!-- BEGIN POST CONTENT -->
												
								<?php if($small_content_display == "full") { ?>	
							
									<?php global $more; $more = 0; the_content('&raquo;'); ?>
								
								<?php } else { ?>
							
									<?php if($small_excerpt_length != "0") { ?><p><?php echo gp_excerpt($small_excerpt_length); ?><?php if($small_read_more == "true") { ?> <a href="<?php the_permalink(); ?>" class="read-more" title="<?php the_title_attribute(); ?>"> &raquo;</a><?php } ?></p><?php } ?>
								
								<?php } ?>
							
								<!-- END POST CONTENT -->
								
								
								<!-- BEGIN POST TAGS -->
								
								<?php if($small_meta == "true" && $small_meta_tags == "true") { ?>
									<?php the_tags('<div class="meta-tags"><span>'.__('Tags', 'gp_lang').':</span>', '', '</div>'); ?>
								<?php } ?>
							
								<!-- END POST TAGS -->
							
																					
							</div>	
						
							<!-- END POST TEXT -->
					
						</div>
					
						<!-- END POST -->
					
							
				<?php } ?>
	
	
		<?php endwhile; ?>


				<?php if($counter > '1') { ?></div><?php } ?>


				<?php if($pages == "true") { ?>
					<?php gp_pagination($featured_query->max_num_pages); ?>
					<div class="clear"></div>
				<?php } ?>


		</div>
	
		<!-- END POST WRAPPER -->


	<?php
	
		wp_reset_query();
		$output_string = ob_get_contents();
		ob_end_clean(); 
	
		return $output_string;

	}
}
add_shortcode("featured_posts", "gp_featured_posts");

?>