<?php // Meta Options (WPShout.com)

require(gp_inc . 'options.php');

add_action('admin_menu', 'gp_create_meta_box');
add_action('save_post', 'gp_save_meta_data');

function gp_create_meta_box() {
	add_meta_box('gp-theme-options', __('Post Settings', 'gp_lang'), 'gp_meta_boxes', 'post', 'normal', 'core');
	add_meta_box('gp-theme-options', __('Page Settings', 'gp_lang'), 'gp_meta_boxes', 'page', 'normal', 'core');	
	add_meta_box('gp-theme-options', __('Slide Settings', 'gp_lang'), 'gp_meta_boxes', 'slide', 'normal', 'core');		
}


/////////////////////////////////////// Post Settings ///////////////////////////////////////


function gp_post_meta_boxes() {
	
	global $dirname;
	
	$meta_boxes = array(

	'thumbnail_settings' => array('name' => 'thumbnail_settings', 'type' => 'open', 'desc' => __('Controls the thumbnails used on category, archive, tag and search result pages.', 'gp_lang'), 'title' => __('Thumbnail Settings', 'gp_lang')),
	
		'_'.$dirname.'_thumbnail_width' => array('name' => '_'.$dirname.'_thumbnail_width', 'title' => __('Thumbnail Width', 'gp_lang'), 'desc' => __('The width to crop the thumbnail to.', 'gp_lang'), 'type' => 'text', 'size' => 'small', 'details' => 'px'),	
				
		'_'.$dirname.'_thumbnail_height' => array('name' => '_'.$dirname.'_thumbnail_height', 'title' => __('Thumbnail Height', 'gp_lang'), 'desc' => __('The height to crop the thumbnail to (set to 0 to have a proportionate height).', 'gp_lang'), 'type' => 'text', 'size' => 'small', 'details' => 'px'),
		
	array('type' => 'separator', 'name' => ''),		
	array('type' => 'close', 'name' => ''),

	'image_settings' => array('name' => 'image_settings', 'type' => 'open', 'desc' => __('Controls the featured image displayed within this page.', 'gp_lang'), 'title' => __('Image Settings', 'gp_lang')),

		'_'.$dirname.'_show_image' => array('name' => '_'.$dirname.'_show_image', 'title' => __('Featured Image', 'gp_lang'), 'desc' => __('Choose whether to display the featured image within your page.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), 'Show' => __('Show', 'gp_lang'), 'Hide' => __('Hide', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),	
		
		'_'.$dirname.'_image_width' => array('name' => '_'.$dirname.'_image_width', 'title' => __('Image Width', 'gp_lang'), 'desc' => __('The width to crop the image to.', 'gp_lang'), 'type' => 'text', 'size' => 'small', 'details' => 'px'),
				
		'_'.$dirname.'_image_height' => array('name' => '_'.$dirname.'_image_height', 'title' => __('Image Height', 'gp_lang'), 'desc' => __('The height to crop the image to (set to 0 to have a proportionate height).', 'gp_lang'), 'type' => 'text', 'size' => 'small', 'details' => 'px'),

		'_'.$dirname.'_image_wrap' => array('name' => '_'.$dirname.'_image_wrap', 'title' => __('Image Wrap', 'gp_lang'), 'desc' => __('Choose whether the page content wraps around the featured image.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), 'Enable' => __('Enable', 'gp_lang'), 'Disable' => __('Disable', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),	
		
		array('type' => 'divider', 'name' => ''),	
		
		'_'.$dirname.'_hard_crop' => array('name' => '_'.$dirname.'_hard_crop', 'title' => __('Hard Crop', 'gp_lang'), 'desc' => __('Choose whether the image is hard cropped.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), 'Enable' => __('Enable', 'gp_lang'), 'Disable' => __('Disable', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),	
						
	array('type' => 'separator', 'name' => ''),		
	array('type' => 'close', 'name' => ''),
		
	'portfolio_settings' => array('name' => 'portfolio_settings', 'type' => 'open', 'desc' => __('Can be used when your posts are displayed in <code>[posts]</code> or <code>[slider]</code> shortcodes.', 'gp_lang'), 'title' => __('Portfolio/Slider Settings', 'gp_lang')),
		
		'_'.$dirname.'_link_type' => array('name' => '_'.$dirname.'_link_type', 'title' => __('Link Type', 'gp_lang'), 'desc' => __('Choose how your portfolio link opens.', 'gp_lang'), 'options' => array('Page' => __('Page', 'gp_lang'), 'Lightbox' => __('Lightbox', 'gp_lang'), 'None' => __('None', 'gp_lang')), 'std' => 'Page', 'type' => 'select'),
	
		'_'.$dirname.'_custom_url' => array('name' => '_'.$dirname.'_custom_url', 'title' => __('Custom URL', 'gp_lang'), 'desc' => __('A custom URL which your image links to (overrides the default post URL).', 'gp_lang'), 'type' => 'text', 'std' => ''),
		
		'_'.$dirname.'_lightbox_content' => array('name' => '_'.$dirname.'_lightbox_content', 'title' => __('Lightbox Content', 'gp_lang'), 'desc' => __('Upload images/audio/videos that will be opened in the lightbox.', 'gp_lang'), 'type' => 'gallery'),
		
		array('type' => 'separator', 'name' => ''),		
		array('type' => 'close', 'name' => ''),
		
	'format_settings' => array('name' => 'format_settings', 'type' => 'open', 'desc' => __('General formatting settings.', 'gp_lang'), 'title' => __('Format Settings', 'gp_lang')),

		'_'.$dirname.'_subtitle' => array('name' => '_'.$dirname.'_subtitle', 'title' => __('Subtitle', 'gp_lang'), 'desc' => __('The subtitle for the page', 'gp_lang'), 'type' => 'text'),

		'_'.$dirname.'_sidebar' => array('name' => '_'.$dirname.'_sidebar', 'title' => __('Sidebar', 'gp_lang'), 'desc' => __('Choose which sidebar area to display on this page.', 'gp_lang'), 'std' => 'Default', 'type' => 'select_sidebar'),

		'_'.$dirname.'_layout' => array('name' => '_'.$dirname.'_layout', 'title' => __('Layout', 'gp_lang'), 'desc' => __('Choose the layout for this page.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), 'sb-left' => __('Sidebar Left', 'gp_lang'), 'sb-right' => __('Sidebar Right', 'gp_lang'), 'fullwidth' => __('Fullwidth', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),
						
		'_'.$dirname.'_title' => array('name' => '_'.$dirname.'_title', 'title' => __('Title', 'gp_lang'), 'desc' => __('Choose whether to display the title on this page.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), 'Show' => __('Show', 'gp_lang'), 'Hide' => __('Hide', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),

		array('type' => 'divider', 'name' => ''),
				
		'_'.$dirname.'_custom_stylesheet' => array('name' => '_'.$dirname.'_custom_stylesheet', 'title' => __('Custom Stylesheet URL', 'gp_lang'), 'desc' => __('Enter the relative URL to your custom stylesheet e.g. <code>lib/css/custom-style.css</code>.', 'gp_lang'), 'type' => 'text', 'details' => ''),

		array('type' => 'separator', 'name' => ''),		
		array('type' => 'close', 'name' => ''),
		
	'review_settings' => array('name' => 'review_settings', 'type' => 'open', 'desc' => __('Review settings.', 'gp_lang'), 'title' => __('Review Settings', 'gp_lang')),	
		
		'_'.$dirname.'_review_box_position' => array('name' => '_'.$dirname.'_review_box_position', 'title' => __('Review Box Position', 'gp_lang'), 'desc' => __('Choose where to position the review box.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), 'top' => __('Top', 'gp_lang'), 'left' => __('Left', 'gp_lang'), 'right' => __('Right', 'gp_lang'), 'bottom' => __('Bottom', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),
				
		'_'.$dirname.'_star_number' => array('name' => '_'.$dirname.'_star_number', 'title' => __('Number Of Stars', 'gp_lang'), 'desc' => __('The number of stars to display.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), '1' => __('1', 'gp_lang'), '2' => __('2', 'gp_lang'), '3' => __('3', 'gp_lang'), '4' => __('4', 'gp_lang'), '5' => __('5', 'gp_lang'), '6' => __('6', 'gp_lang'), '7' => __('7', 'gp_lang'), '8' => __('8', 'gp_lang'), '9' => __('9', 'gp_lang'), '10' => __('10', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),	
		
		'_'.$dirname.'_user_rating' => array('name' => '_'.$dirname.'_user_rating', 'title' => __('User Rating', 'gp_lang'), 'desc' => __('Choose whether to allow users to rate this post.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), 'Enable' => __('Enable', 'gp_lang'), 'Disable' => __('Disable', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),
		
		array('type' => 'divider', 'name' => ''),
				
		'_'.$dirname.'_review_criteria_1' => array('name' => '_'.$dirname.'_review_criteria_1', 'title' => __('Criteria', 'gp_lang'), 'type' => 'text'),

		'_'.$dirname.'_review_score_1' => array('name' => '_'.$dirname.'_review_score_1', 'title' => __('Score', 'gp_lang'), 'size' => 'small', 'type' => 'text'),
		
		array('type' => 'clear', 'name' => ''),

		'_'.$dirname.'_review_criteria_2' => array('name' => '_'.$dirname.'_review_criteria_2', 'title' => '', 'type' => 'text'),

		'_'.$dirname.'_review_score_2' => array('name' => '_'.$dirname.'_review_score_2', 'title' => '', 'size' => 'small', 'type' => 'text'),		

		array('type' => 'clear', 'name' => ''),

		'_'.$dirname.'_review_criteria_3' => array('name' => '_'.$dirname.'_review_criteria_3', 'title' => '', 'type' => 'text'),

		'_'.$dirname.'_review_score_3' => array('name' => '_'.$dirname.'_review_score_3', 'title' => '', 'size' => 'small', 'type' => 'text'),	
		
		array('type' => 'clear', 'name' => ''),

		'_'.$dirname.'_review_criteria_4' => array('name' => '_'.$dirname.'_review_criteria_4', 'title' => '', 'type' => 'text'),

		'_'.$dirname.'_review_score_4' => array('name' => '_'.$dirname.'_review_score_4', 'title' => '', 'size' => 'small', 'type' => 'text'),	
		
		array('type' => 'clear', 'name' => ''),

		'_'.$dirname.'_review_criteria_5' => array('name' => '_'.$dirname.'_review_criteria_5', 'title' => '', 'type' => 'text'),

		'_'.$dirname.'_review_score_5' => array('name' => '_'.$dirname.'_review_score_5', 'title' => '', 'size' => 'small', 'type' => 'text'),	
		
		array('type' => 'clear', 'name' => ''),

		'_'.$dirname.'_review_criteria_6' => array('name' => '_'.$dirname.'_review_criteria_6', 'title' => '', 'type' => 'text'),

		'_'.$dirname.'_review_score_6' => array('name' => '_'.$dirname.'_review_score_6', 'title' => '', 'size' => 'small', 'type' => 'text'),				
		
		array('type' => 'clear', 'name' => ''),
		
		'_'.$dirname.'_total_score_text' => array('name' => '_'.$dirname.'_total_score_text', 'title' => __('Total Score Text', 'gp_lang'), 'desc' => __('The text used to describe your final score.', 'gp_lang'), 'type' => 'text'),		
		
		'_'.$dirname.'_total_score' => array('name' => '_'.$dirname.'_total_score', 'title' => __('Total Score', 'gp_lang'), 'desc' => __('Leave blank if you are using criteria above.', 'gp_lang'), 'size' => 'small', 'type' => 'text'),								

		array('type' => 'divider', 'name' => ''),
				
		'_'.$dirname.'_summary' => array('name' => '_'.$dirname.'_summary', 'title' => __('Summary', 'gp_lang'), 'desc' => __('The summary of this review.', 'gp_lang'), 'type' => 'textarea'),
						
				
	array('type' => 'close', 'name' => ''),	
	array('type' => 'clear', 'name' => ''),
	
	);

	return apply_filters('_'.$dirname.'_post_meta_boxes', $meta_boxes);
}


/////////////////////////////////////// Page Settings ///////////////////////////////////////


function gp_page_meta_boxes() {
	
	global $dirname;

	$meta_boxes = array(
	
	'thumbnail_settings' => array('name' => 'thumbnail_settings', 'type' => 'open', 'desc' => __('Controls the thumbnails used on category, archive, tag and search result pages.', 'gp_lang'), 'title' => __('Thumbnail Settings', 'gp_lang')),
		
		'_'.$dirname.'_thumbnail_width' => array('name' => '_'.$dirname.'_thumbnail_width', 'title' => __('Thumbnail Width', 'gp_lang'), 'desc' => __('The width to crop the thumbnail to.', 'gp_lang'), 'type' => 'text', 'size' => 'small', 'details' => 'px'),	
				
		'_'.$dirname.'_thumbnail_height' => array('name' => '_'.$dirname.'_thumbnail_height', 'title' => __('Thumbnail Height', 'gp_lang'), 'desc' => __('The height to crop the thumbnail to (set to 0 to have a proportionate height).', 'gp_lang'), 'type' => 'text', 'size' => 'small', 'details' => 'px'),	

	array('type' => 'separator', 'name' => ''),		
	array('type' => 'close', 'name' => ''),

	'image_settings' => array('name' => 'image_settings', 'type' => 'open', 'desc' => __('Controls the featured image displayed within this page.', 'gp_lang'), 'title' => __('Image Settings', 'gp_lang')),

		'_'.$dirname.'_show_image' => array('name' => '_'.$dirname.'_show_image', 'title' => __('Featured Image', 'gp_lang'), 'desc' => __('Choose whether to display the featured image within your page.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), 'Show' => __('Show', 'gp_lang'), 'Hide' => __('Hide', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),	
		
		'_'.$dirname.'_image_width' => array('name' => '_'.$dirname.'_image_width', 'title' => __('Image Width', 'gp_lang'), 'desc' => __('The width to crop the image to.', 'gp_lang'), 'type' => 'text', 'size' => 'small', 'details' => 'px'),
				
		'_'.$dirname.'_image_height' => array('name' => '_'.$dirname.'_image_height', 'title' => __('Image Height', 'gp_lang'), 'desc' => __('The height to crop the image to (set to 0 to have a proportionate height).', 'gp_lang'), 'type' => 'text', 'size' => 'small', 'details' => 'px'),

		'_'.$dirname.'_image_wrap' => array('name' => '_'.$dirname.'_image_wrap', 'title' => __('Image Wrap', 'gp_lang'), 'desc' => __('Choose whether the page content wraps around the featured image.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), 'Enable' => __('Enable', 'gp_lang'), 'Disable' => __('Disable', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),	
		
		array('type' => 'divider', 'name' => ''),	
		
		'_'.$dirname.'_hard_crop' => array('name' => '_'.$dirname.'_hard_crop', 'title' => __('Hard Crop', 'gp_lang'), 'desc' => __('Choose whether the image is hard cropped.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), 'Enable' => __('Enable', 'gp_lang'), 'Disable' => __('Disable', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),	
								
	array('type' => 'separator', 'name' => ''),		
	array('type' => 'close', 'name' => ''),
		
	'format_settings' => array('name' => 'format_settings', 'type' => 'open', 'desc' => __('General formatting settings.', 'gp_lang'), 'title' => __('Format Settings', 'gp_lang')),

		'_'.$dirname.'_subtitle' => array('name' => '_'.$dirname.'_subtitle', 'title' => __('Subtitle', 'gp_lang'), 'desc' => __('The subtitle for the page', 'gp_lang'), 'type' => 'text', 'details' => ''),

		'_'.$dirname.'_sidebar' => array('name' => '_'.$dirname.'_sidebar', 'title' => __('Sidebar', 'gp_lang'), 'desc' => __('Choose which sidebar area to display on this page.', 'gp_lang'), 'std' => 'Default', 'type' => 'select_sidebar'),

		'_'.$dirname.'_layout' => array('name' => '_'.$dirname.'_layout', 'title' => __('Layout', 'gp_lang'), 'desc' => __('Choose the layout for this page.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), 'sb-left' => __('Sidebar Left', 'gp_lang'), 'sb-right' => __('Sidebar Right', 'gp_lang'), 'fullwidth' => __('Fullwidth', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),
				
		'_'.$dirname.'_title' => array('name' => '_'.$dirname.'_title', 'title' => __('Title', 'gp_lang'), 'desc' => __('Choose whether to display the title on this page.', 'gp_lang'), 'options' => array('Default' => __('Default', 'gp_lang'), 'Show' => __('Show', 'gp_lang'), 'Hide' => __('Hide', 'gp_lang')), 'std' => 'Default', 'type' => 'select'),
		
		array('type' => 'divider', 'name' => ''),	
		
		'_'.$dirname.'_custom_stylesheet' => array('name' => '_'.$dirname.'_custom_stylesheet', 'title' => __('Custom Stylesheet URL', 'gp_lang'), 'desc' => __('Enter the relative URL to your custom stylesheet e.g. <code>lib/css/custom-style.css</code>.', 'gp_lang'), 'type' => 'text'),
	
	array('type' => 'close', 'name' => ''),	
	array('type' => 'clear', 'name' => ''),
	
	);

	return apply_filters('_'.$dirname.'_page_meta_boxes', $meta_boxes);
}


/////////////////////////////////////// Slide Settings ///////////////////////////////////////

	 
function gp_slide_meta_boxes() {
	
	global $dirname;
	
	$meta_boxes = array(

	'format_settings' => array('name' => 'format_settings', 'type' => 'open', 'desc' => __('General product slide settings.', 'gp_lang'), 'title' => __('Format Settings', 'gp_lang')),
		
		'_'.$dirname.'_custom_url' => array('name' => '_'.$dirname.'_custom_url', 'title' => __('Slide URL', 'gp_lang'), 'desc' => __('Enter the URL you want your slide to link to.', 'gp_lang'), 'type' => 'text'),

		'_'.$dirname.'_link_type' => array('name' => '_'.$dirname.'_link_type', 'title' => __('Link Type', 'gp_lang'), 'desc' => __('Choose how your slide links to the URL you provided to the left.', 'gp_lang'), 'options' => array('Page' => __('Page', 'gp_lang'), 'Lightbox' => __('Lightbox', 'gp_lang'), 'None' => __('None', 'gp_lang')), 'std' => 'Page', 'type' => 'select'),
		
	array('type' => 'separator', 'name' => ''),		
	array('type' => 'close', 'name' => ''),
	
	'caption_settings' => array('name' => 'caption_settings', 'type' => 'open', 'desc' => __('The settings for a caption in this slide.', 'gp_lang'),  'title' => __('Caption Settings', 'gp_lang')),
		
		'_'.$dirname.'_slide_title' => array('name' => '_'.$dirname.'_slide_title', 'title' => __('Hide Slide Caption Title', 'gp_lang'), 'desc' => __('Hide the slide caption title.', 'gp_lang'), 'type' => 'checkbox'),
							
	array('type' => 'close', 'name' => ''),
	array('type' => 'clear', 'name' => ''),	
	
	);

	return apply_filters('_'.$dirname.'_slide_meta_boxes', $meta_boxes);
}


/////////////////////////////////////// Meta Fields ///////////////////////////////////////


function gp_meta_boxes() {
	global $post;
	
	if(get_post_type() == 'post') {
		$meta_boxes = gp_post_meta_boxes();	
	} elseif(get_post_type() == 'slide') {
		$meta_boxes = gp_slide_meta_boxes();		
	} else {
		$meta_boxes = gp_page_meta_boxes();
	}
	
	foreach($meta_boxes as $meta) :
	if(isset($meta['name'])) { $value = get_post_meta($post->ID, $meta['name'], true); }
	if($meta['type'] == 'text')
		get_meta_text($meta, $value);	
	elseif($meta['type'] == 'upload')
		get_meta_upload($meta, $value);				
	elseif($meta['type'] == 'textarea')
		get_meta_textarea($meta, $value);
	elseif($meta['type'] == 'select')
		get_meta_select($meta, $value);
	elseif($meta['type'] == 'select_sidebar')
		get_meta_select_sidebar($meta, $value);			
	elseif($meta['type'] == 'checkbox')
		get_meta_checkbox($meta, $value);			
	elseif($meta['type'] == 'open')
		get_meta_open($meta, $value);		
	elseif($meta['type'] == 'close')
		get_meta_close($meta, $value);
	elseif($meta['type'] == 'divider')
		get_meta_divider($meta, $value);	
	elseif ($meta['type'] == 'separator')
		get_meta_separator($meta, $value);					
	elseif($meta['type'] == 'clear')
		get_meta_clear($meta, $value);
	elseif($meta['type'] == 'gallery')
		get_meta_gallery($meta, $value);
	elseif($meta['type'] == 'colorpicker')
		get_meta_colorpicker($meta, $value);				
	endforeach;
			
} function get_meta_open($args = array(), $value = false, $title = false ) {
extract($args); ?>
	
	<div class="meta-settings" id="<?php echo $name; ?>">
	
		<h2><?php echo $title; ?></h2>
		<div class="clear"></div>
	
		<?php if ( $desc ) { ?><div class="meta-settings-desc"><?php echo $desc; ?></div><div class="clear"></div><?php } ?>
	
		<input type="hidden" name="<?php echo $name; ?>_noncename" id="<?php echo $name; ?>_noncename" value="<?php echo wp_create_nonce(plugin_basename(__FILE__)); ?>" />		
	
	
<?php } function get_meta_close($args = array(), $value = false) {
extract($args); ?>
	
	</div><div class="clear"></div>
	
	<input type="hidden" name="_noncename" id="_noncename" value="<?php echo wp_create_nonce(plugin_basename(__FILE__)); ?>" />		
	
	
<?php } function get_meta_divider($args = array(), $value = false) {
extract($args); ?>

	<div class="clear"></div>
	<div class="divider"></div>
	<input type="hidden" name="_noncename" id="_noncename" value="<?php echo wp_create_nonce(plugin_basename(__FILE__)); ?>" />		


<?php } function get_meta_separator($args = array(), $value = false) {
extract($args); ?>
	
	<div class="clear"></div>
	<div class="separator"></div>
	<input type="hidden" name="_noncename" id="_noncename" value="<?php echo wp_create_nonce(plugin_basename(__FILE__)); ?>" />		
	
	
<?php } function get_meta_clear($args = array(), $value = false) {
extract($args); ?>
	
	<div class="clear"></div>
	<input type="hidden" name="_noncename" id="_noncename" value="<?php echo wp_create_nonce(plugin_basename(__FILE__)); ?>" />		
	
	
<?php } function get_meta_text($args = array(), $value = false, $desc = false, $details = false, $size = '', $std = '', $title = false ) {
extract($args); global $post; ?>

	<div id="meta-box-<?php echo $name; ?>" class="meta-box<?php if($size == "small") { ?> text-small<?php } ?>">
		<?php if($title) { ?><strong><?php echo $title; ?></strong><br/><?php } ?>
		<input type="text" name="<?php echo $name; ?>" id="<?php echo $name; ?>" value="<?php if($value != "") { echo esc_html($value, 1); } else { echo $std; } ?>" size="<?php if($size == "small") { ?>3<?php } else { ?>30<?php } ?>" /><?php if($details) { ?> <span><?php echo $details; ?></span><?php } ?>
		<?php if ( $desc ) { ?><div class="meta-box-desc"><?php echo $desc; ?></div><?php } ?>
		<input type="hidden" name="<?php echo $name; ?>_noncename" id="<?php echo $name; ?>_noncename" value="<?php echo wp_create_nonce(plugin_basename(__FILE__)); ?>" />
	</div>


<?php } function get_meta_upload($args = array(), $value = false, $desc = false, $std = '', $title = false ) {
extract($args); global $post; ?>

	<div id="meta-box-<?php echo $name; ?>" class="meta-box uploader">
		<?php if($title) { ?><strong><?php echo $title; ?></strong><br/><?php } ?>
		<input type="text" name="<?php echo $name; ?>" id="<?php echo $name; ?>" class="upload" value="<?php if($value != "") { echo esc_html($value, 1); } else { echo $std; } ?>" size="30" />
		<input type="button" id="<?php echo $name; ?>_button" class="upload-image-button button" value="<?php _e('Upload', 'gp_lang'); ?>" />
		<?php if ( $desc ) { ?><div class="meta-box-desc"><?php echo $desc; ?></div><?php } ?>
		<input type="hidden" name="<?php echo $name; ?>_noncename" id="<?php echo $name; ?>_noncename" value="<?php echo wp_create_nonce(plugin_basename(__FILE__)); ?>" />
	</div>
	
	
<?php } function get_meta_select($args = array(), $value = false, $desc = false, $std = '', $title = false  ) {
extract($args); ?>
	
	<div id="meta-box-<?php echo $name; ?>" class="meta-box">
		<?php if($title) { ?><strong><?php echo $title; ?></strong><br/><?php } ?>
		<select name="<?php echo $name; ?>" id="<?php echo $name; ?>">
		<?php foreach($options as $key=>$option) : ?>
			<?php if($value != "") { ?>
				<option value="<?php echo $key; ?>" <?php if(htmlentities($value, ENT_QUOTES) == $key) echo ' selected="selected"'; ?>><?php echo $option; ?></option>
			<?php } else { ?>
				<option value="<?php echo $key; ?>" <?php if($std == $key) { echo ' selected="selected"'; } ?>><?php echo $option; ?></option>
			<?php } ?>	
		<?php endforeach; ?>
		</select>
		<?php if ( $desc ) { ?><div class="meta-box-desc"><?php echo $desc; ?></div><?php } ?>
		<input type="hidden" name="<?php echo $name; ?>_noncename" id="<?php echo $name; ?>_noncename" value="<?php echo wp_create_nonce(plugin_basename(__FILE__)); ?>" />
	</div>


<?php } function get_meta_select_sidebar($args = array(), $value = false, $desc = false, $std = '', $title = false ) {
extract($args); global $post, $wp_registered_sidebars; ?>

	<div id="meta-box-<?php echo $name; ?>" class="meta-box">
		<?php if($title) { ?><strong><?php echo $title; ?></strong><br/><?php } ?>
		<select name="<?php echo $name; ?>" id="<?php echo $name; ?>">
			<option value="Default" <?php if(htmlentities($value, ENT_QUOTES) == 'Default') echo ' selected="selected"'; ?>><?php _e('Default', 'gp_lang'); ?></option>
			<?php $sidebars = $wp_registered_sidebars;
			if(is_array($sidebars) && !empty($sidebars)) { foreach($sidebars as $sidebar) { if($value != '') { ?>
				<option value="<?php echo $sidebar['id']; ?>"<?php if($value == $sidebar['id']) { echo ' selected="selected"'; } ?>><?php echo $sidebar['name']; ?></option>
			<?php } else { ?>
				<option value="<?php echo $sidebar['id']; ?>"<?php if($std == $sidebar['id']) { echo ' selected="selected"'; } ?>><?php echo $sidebar['name']; ?></option>
			<?php }}} ?>
		</select>
		<?php if ( $desc ) { ?><div class="meta-box-desc"><?php echo $desc; ?></div><?php } ?>
		<input type="hidden" name="<?php echo $name; ?>_noncename" id="<?php echo $name; ?>_noncename" value="<?php echo wp_create_nonce(plugin_basename(__FILE__)); ?>" />
	</div>
	
		
<?php } function get_meta_textarea($args = array(), $value = false, $desc = false, $size = '', $std = '', $title = false ) {
extract($args); ?>

	<div id="meta-box-<?php echo $name; ?>" class="meta-box<?php if($size == "large") { ?> text-large<?php } ?>">	
		<?php if($title) { ?><strong><?php echo $title; ?></strong><br/><?php } ?>
		<textarea name="<?php echo $name; ?>" id="<?php echo $name; ?>" cols="60" rows="4" tabindex="30"><?php if ( $value != '' ) { echo esc_html( $value, 1 ); } else { echo $std; } ?></textarea>
		<?php if ( $desc ) { ?><div class="meta-box-desc"><?php echo $desc; ?></div><?php } ?>
		<input type="hidden" name="<?php echo $name; ?>_noncename" id="<?php echo $name; ?>_noncename" value="<?php echo wp_create_nonce(plugin_basename(__FILE__)); ?>" />
	</div>


<?php } function get_meta_checkbox($args = array(), $value = false, $desc = false, $std = '', $title = false ) {
extract($args); ?>

	<div id="meta-box-<?php echo $name; ?>" class="meta-box">
		<?php if($title) { ?><strong><?php echo $title; ?></strong><?php } ?>
		<?php if(esc_html($value, 1)) { $checked = "checked=\"checked\""; } else { if($std === "true") { $checked = "checked=\"checked\""; } else { $checked = ""; } } ?>
		<input type="checkbox" name="<?php echo $name; ?>" id="<?php echo $name; ?>" value="false" <?php echo $checked; ?> />
		<?php if ( $desc ) { ?><div class="meta-box-desc"><?php echo $desc; ?></div><?php } ?>
		<input type="hidden" name="<?php echo $name; ?>_noncename" id="<?php echo $name; ?>_noncename" value="<?php echo wp_create_nonce(plugin_basename(__FILE__)); ?>" />		
	</div>
	

<?php } function get_meta_gallery( $args = array(), $value = false, $desc = false, $title = false ) {
extract($args); global $post; ?>

	<div id="meta-box-<?php echo $name; ?>" class="meta-box">
	
		<?php if($title) { ?><strong><?php echo $title; ?></strong><?php } ?>
		<div class="clear"></div>
			
		<div id="wp-content-media-buttons" class="wp-media-buttons" style="margin-top: 5px;">
			<a href="#" class="button insert-media add_media" data-editor="content" title="<?php _e('Add Media', 'gp_lang'); ?>"><span class="wp-media-buttons-icon"></span> <?php _e('Add Media', 'gp_lang'); ?></a>
		</div>
		
		<div class="clear"></div>
		
		<?php if ( $desc ) { ?><div class="meta-box-desc"><?php echo $desc; ?></div><?php } ?>
		
		<?php $image_url = site_url().'/wp-includes/images/crystal/video.png';
		$args = array('post_type' => 'attachment', 'post_parent' => $post->ID, 'numberposts' => -1, 'orderby' => 'date', 'order' => 'desc', 'post__not_in' => array(get_post_thumbnail_id())); $attachments = get_children($args); ?>		
		<?php if($attachments) { foreach ($attachments as $attachment) { ?>
			<?php if($attachment->post_mime_type == 'image/jpeg' OR $attachment->post_mime_type == 'image/jpg' OR $attachment->post_mime_type == 'image/png' OR $attachment->post_mime_type == 'image/gif') { $image = aq_resize(wp_get_attachment_url($attachment->ID), 100, 100, true, true, true); } else { $image = site_url().'/wp-includes/images/crystal/video.png'; } ?>
			<img src="<?php echo $image; ?>" width="50" height="50" alt="" style="margin-top: 5px;" />
		<?php }} ?>		
		<input type="hidden" name="<?php echo $name; ?>_noncename" id="<?php echo $name; ?>_noncename" value="<?php echo wp_create_nonce( plugin_basename( __FILE__ ) ); ?>" />
	
	</div>
	

<?php } function get_meta_colorpicker( $args = array(), $value = false, $desc = false, $std = '', $title = false ) {
extract($args); ?>

	<div id="meta-box-<?php echo $name; ?>" class="meta-box">
		<script type="text/javascript">
			jQuery(document).ready(function($){  
				$("#<?php echo $name; ?>").wpColorPicker();
			});
		</script>
		<?php if($title) { ?><strong><?php echo $title; ?></strong><br/><?php } ?>
		<input type="text" name="<?php echo $name; ?>" id="<?php echo $name; ?>" value="<?php if($value != "") { echo $value; } else { echo $std; } ?>" />
		<?php if ( $desc ) { ?><div class="meta-box-desc"><?php echo $desc; ?></div><?php } ?>
		<input type="hidden" name="<?php echo $name; ?>_noncename" id="<?php echo $name; ?>_noncename" value="<?php echo wp_create_nonce(plugin_basename(__FILE__)); ?>" />
	</div>
	

<?php }

if(is_admin() && ($pagenow == "post.php" OR $pagenow == "post-new.php")) {	
	function gp_admin_scripts() {	
		wp_enqueue_style('gp-admin', get_template_directory_uri().'/lib/admin/css/admin.css');
		wp_enqueue_style('wp-color-picker');
		if(!has_action('admin_footer', 'wp_print_media_templates')) wp_enqueue_media();
		wp_enqueue_script('wp-color-picker');
		wp_enqueue_script('gp-uploader', get_template_directory_uri().'/lib/admin/scripts/uploader.js');
	}	
	add_action('admin_print_scripts', 'gp_admin_scripts');
}

function gp_save_meta_data($post_id) {
	global $post;

	if(isset($_POST['post_type']) && 'post' == $_POST['post_type'])
		$meta_boxes = array_merge(gp_post_meta_boxes());
	elseif(isset($_POST['post_type']) && 'slide' == $_POST['post_type'])
		$meta_boxes = array_merge(gp_slide_meta_boxes());	
	else
		$meta_boxes = array_merge(gp_page_meta_boxes());
				
	foreach ($meta_boxes as $meta_box) :
		
		if(!isset($_POST[$meta_box['name'] . '_noncename']) OR !wp_verify_nonce($_POST[$meta_box['name'] . '_noncename'], plugin_basename(__FILE__)))
			return $post_id;

		if(defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) 
			return $post_id;
      
		if(!current_user_can('edit_post', $post_id))
			return $post_id;
					
		$data = sanitize_text_field($_POST[$meta_box['name']]);
		
		if(get_post_meta($post_id, $meta_box['name']) == '')
			add_post_meta($post_id, $meta_box['name'], $data, true);

		elseif($data != get_post_meta($post_id, $meta_box['name'], true))
			update_post_meta($post_id, $meta_box['name'], $data);

		elseif($data == '')
			delete_post_meta($post_id, $meta_box['name'], get_post_meta($post_id, $meta_box['name'], true));

	endforeach;
}

?>