<?php 

/////////////////////////////////////// Categorey Fields ///////////////////////////////////////


if(is_admin() && $pagenow == "edit-tags.php") {
	function gp_cat_scripts() {
		wp_enqueue_style('gp-admin', get_template_directory_uri().'/lib/admin/css/admin.css');	
		wp_enqueue_style('wp-color-picker');
		wp_enqueue_script('wp-color-picker');
	}
	add_action('admin_print_scripts', 'gp_cat_scripts');
}		

function gp_category_custom_fields($tag) {

	if ( isset( $tag->term_id ) ) {
		$t_id = $tag->term_id;
		$category_meta = get_option( "category_$t_id" );
	} else {
		$category_meta = null;
	} ?>
    
    <tr class="form-field">
       
        <th scope="row" valign="top"><label for="category-color"><?php _e('Color', 'gp_lang'); ?></label></th>
        
        <td>

			<script type="text/javascript">
				jQuery(document).ready(function($){  
					$("#category_meta").wpColorPicker();
				});
			</script>
				
            <input type="text" id="category_meta" name="category_meta[color]" value="<?php if($category_meta['color']) { echo $category_meta['color']; } ?>" />
            <p class="description"><?php _e('Select a color to associate with this category.', 'gp_lang'); ?></p>
            
        </td>
        
    </tr>
   
<?php

}

function gp_save_category_custom_fields($term_id) {
    if(isset( $_POST['category_meta'])) {
        $t_id = $term_id;
        $category_meta = get_option( "category_$t_id");
        $cat_keys = array_keys($_POST['category_meta']);
            foreach ($cat_keys as $key){
            if (isset($_POST['category_meta'][$key])) {
                $category_meta[$key] = $_POST['category_meta'][$key];
            }
        }
        update_option("category_$t_id", $category_meta);
    }
}

add_action('category_add_form_fields', 'gp_category_custom_fields');
add_action('created_category', 'gp_save_category_custom_fields');
add_action('edit_category_form_fields', 'gp_category_custom_fields');
add_action('edit_category', 'gp_save_category_custom_fields');


/////////////////////////////////////// Media Fields ///////////////////////////////////////


function gp_edit_attachment($form_fields, $post) {

	global $dirname;


	// Lightbox
	
	$form_fields[$dirname.'_lightbox_url'] = array(
		"label" => __('Lightbox URL', 'gp_lang'),
		"input" => "text",
		"value" => get_post_meta($post->ID, '_'.$dirname.'_lightbox_url', true),
		"helps" => __('The URL of an image, video or audio file that loads in the lightbox.', 'gp_lang'),
	);
			
						
	return $form_fields;

}
add_filter("attachment_fields_to_edit", "gp_edit_attachment", null, 2);


function gp_save_attachment($post, $attachment) {
	
	global $dirname;
	
	
	// Lightbox URL
	
	if(isset($attachment[$dirname.'_lightbox_url'])){
		update_post_meta($post['ID'], '_'.$dirname.'_lightbox_url', $attachment[$dirname.'_lightbox_url']);
	}	
	
	
	return $post;
	
}
add_filter("attachment_fields_to_save", "gp_save_attachment", null , 2);


?>