<?php


/////////////////////////////////////// Custom Styling ///////////////////////////////////////


// Convert hex codes to rgb

function hex2rgb($hex) {
	$hex = str_replace("#", "", $hex);	
	if(strlen($hex) == 3) {
		$r = hexdec(substr($hex,0,1).substr($hex,0,1));
		$g = hexdec(substr($hex,1,1).substr($hex,1,1));
		$b = hexdec(substr($hex,2,1).substr($hex,2,1));
		$rgb = array($r, $g, $b);
		return implode(",", $rgb);
	} elseif(strlen($hex) > 3) {
		$r = hexdec(substr($hex,0,2));
		$g = hexdec(substr($hex,2,2));
		$b = hexdec(substr($hex,4,2));
		$rgb = array($r, $g, $b);
		return implode(",", $rgb);
	} else {}
}


// Custom CSS

global $dirname;
$custom_css = "";

	
// Primary

if(get_option($dirname.'_primary_text_color')) {
	$custom_css .= 'body, input, textarea, select {color: '.get_option($dirname.'_primary_text_color').';}';
}

if(get_option($dirname.'_primary_font')) {	
	$custom_css .= 'body, input, textarea, select {font-family: "'.get_option($dirname.'_primary_font').'";}';
}

if(get_option($dirname.'_primary_size')) {
	$custom_css .= 'body, input, textarea, select {font-size: '.get_option($dirname.'_primary_size').'px;}';
}
	
if(get_option($dirname.'_primary_link_color')) {
	$custom_css .= 'a {color: '.get_option($dirname.'_primary_link_color').';}';
}

if(get_option($dirname.'_primary_link_hover_color')) {
	$custom_css .= 'a:hover {color: '.get_option($dirname.'_primary_link_hover_color').';}';
}

if(get_option($dirname.'_primary_bg_color')) {
	$custom_css .= '#content-wrapper {background-color: '.get_option($dirname.'_primary_bg_color').';}';
}	
		
if(get_option($dirname.'_primary_border_color')) {
	$custom_css .= '.post-meta, .sc-divider, .author-info, .separate > div, .joint > div {border-color:'.get_option($dirname.'_primary_border_color').';}';
}	

if(get_option($dirname.'_primary_padding')) {
	$custom_css .= '#content-wrapper {padding: '.get_option($dirname.'_primary_padding').'px;}';
}


// Secondary

if(get_option($dirname.'_secondary_link_color')) {
	$custom_css .= '.widget li a {color: '.get_option($dirname.'_secondary_link_color').';}';
}

if(get_option($dirname.'_secondary_link_hover_color')) {
	$custom_css .= '.widget li a:hover {color: '.get_option($dirname.'_secondary_link_hover_color').';}';
}
		
if(get_option($dirname.'_secondary_text_color')) {
	$custom_css .= 'input[type="button"], input[type="submit"], input[type="reset"], #searchsubmit, .popular-widget ul.pop-widget-tabs li a, .carousel-nav > a, #wp-calendar #today a, .tagcloud a, .popular-widget div.pop-inside ul.wp-tag-cloud li a, #toTop, .single-post .meta-cats a, .comment-reply-link, #cancel-comment-reply-link {color: '.get_option($dirname.'_secondary_text_color').';}';
	$custom_css .= '::selection {color: '.get_option($dirname.'_secondary_text_color').';}';
	$custom_css .= '::-moz-selection {color: '.get_option($dirname.'_secondary_text_color').';}';		
}	
		
if(get_option($dirname.'_secondary_bg_color')) {		
	$custom_css .= 'input[type="button"], input[type="submit"], input[type="reset"], #searchsubmit, .popular-widget ul.pop-widget-tabs, .popular-widget ul.pop-widget-tabs li a, .carousel-nav > a, #wp-calendar #today, .tagcloud a, .popular-widget div.pop-inside ul.wp-tag-cloud li a, #toTop, .flex-control-nav li a, #gp-total-score-wrapper, .single-post .meta-cats a:hover, .comment-reply-link:hover, #cancel-comment-reply-link:hover, .wp-pagenavi .current, .wp-pagenavi.cat-navi a:hover, .wp-pagenavi.comment-navi a:hover, .wp-pagenavi .page:hover, .wp-pagenavi.post-navi span, .wp-pagenavi.post-navi a span:hover {background-color: '.get_option($dirname.'_secondary_bg_color').';}';
	$custom_css .= '::selection {background-color: '.get_option($dirname.'_secondary_bg_color').';}';
	$custom_css .= '::-moz-selection {background-color: '.get_option($dirname.'_secondary_bg_color').';}';
}


if(get_option($dirname.'_secondary_bg_hover_color')) {
	$custom_css .= 'input[type="button"]:hover, input[type="submit"]:hover, input[type="reset"]:hover, #searchsubmit:hover, .popular-widget ul.pop-widget-tabs li a.active, .popular-widget ul.pop-widget-tabs li a:hover, .carousel-nav > a:hover, .tagcloud a:hover, .popular-widget div.pop-inside ul.wp-tag-cloud li a:hover, #toTop:hover, .flex-control-nav li a:hover, .flex-control-nav li .flex-active, .single-post .meta-cats a, .cat-title .page-title, .comment-reply-link, #cancel-comment-reply-link, .wp-pagenavi span, .wp-pagenavi.cat-navi a, .wp-pagenavi.comment-navi a, .wp-pagenavi.post-navi a span {background-color: '.get_option($dirname.'_secondary_bg_hover_color').';}';
}

if(get_option($dirname.'_secondary_border_color_1')) {		
	$custom_css .= '.footer-widget .widget .widgettitle {border-color: '.get_option($dirname.'_secondary_border_color_1').';}';
}

if(get_option($dirname.'_secondary_border_color_2')) {		
	$custom_css .= '.widget .widgettitle {border-color: '.get_option($dirname.'_secondary_border_color_2').';}';
}
	

// Tertiary

if(get_option($dirname.'_tertiary_bg_color')) {
	$custom_css .= '#footer, .ui-tabs .ui-tabs-nav li.ui-tabs-active, .sc-tab-panel {background-color: '.get_option($dirname.'_tertiary_bg_color').';}';
}
if(get_option($dirname.'_tertiary_border_color')) {
	$custom_css .= '#footer {border-color: '.get_option($dirname.'_tertiary_border_color').';}';
}			

// Quaternary

if(get_option($dirname.'_quaternary_text_color')) {
	$custom_css .= '.meta-tags a {color: '.get_option($dirname.'_quaternary_text_color').';}';
}	
if(get_option($dirname.'_quaternary_bg_color')) {
	$custom_css .= '.meta-tags a {background-color: '.get_option($dirname.'_quaternary_bg_color').';}';
}
if(get_option($dirname.'_quaternary_bg_hover_color')) {
	$custom_css .= '.meta-tags a:hover {background-color: '.get_option($dirname.'_quaternary_bg_hover_color').';}';
}			
	
				
// Icons

if(get_option($dirname.'_icon_color')) {
	$custom_css .= '[class^="icon-"]::before, [class*=" icon-"]::before {color: '.get_option($dirname.'_icon_color').';}';
}	

if(get_option($dirname.'_icon_hover_color')) {
	$custom_css .= '[class^="icon-"]:hover::before, [class*=" icon-"]:hover::before {color: '.get_option($dirname.'_icon_hover_color').' !important;}';
}
			
		
// Headings

if(get_option($dirname.'_heading_text_color')) {
	$custom_css .= 'h1, h2, h3, h4, h5, h6, .widget .widgettitle {color: '.get_option($dirname.'_heading_text_color').';}';
}	

if(get_option($dirname.'_heading_font')) {
	$custom_css .= 'h1, h2, h3, h4, h5, h6, .widget .widgettitle {font-family: "'.get_option($dirname.'_heading_font').'";}';
}	

if(get_option($dirname.'_heading1_size')) {
	$custom_css .= 'h1 {font-size: '.get_option($dirname.'_heading1_size').'px;}';
}	

if(get_option($dirname.'_heading2_size')) {
	$custom_css .= 'h2 {font-size: '.get_option($dirname.'_heading2_size').'px;}';
}
	
if(get_option($dirname.'_heading3_size')) {
	$custom_css .= 'h3 {font-size: '.get_option($dirname.'_heading3_size').'px;}';
}
	
if(get_option($dirname.'_heading_link_color')) {				
	$custom_css .= 'h1 a, h2 a, h3 a, h4 a, h5 a, h6 a {color: '.get_option($dirname.'_heading_link_color').';}';
}

if(get_option($dirname.'_heading_link_hover_color')) {
	$custom_css .= 'h1 a:hover, h2 a:hover, h3 a:hover, h4 a:hover, h5 a:hover, h6 a:hover {color: '.get_option($dirname.'_heading_link_hover_color').';}';
}	


// Top Bar

if(get_option($dirname.'_top_bar_outer_bg_color')) {
	$custom_css .= '#top-bar {background-color: '.get_option($dirname.'_top_bar_outer_bg_color').';}';
}	

if(get_option($dirname.'_top_bar_inner_bg_color')) {
	$custom_css .= '#top-bar-inner {background-color: '.get_option($dirname.'_top_bar_inner_bg_color').';}';
}	

if(get_option($dirname.'_top_bar_nav_dropdown_bg_color')) {
	$custom_css .= '#top-nav.nav .menu li:hover > a, #top-nav.nav .menu .sub-menu {background-color: '.get_option($dirname.'_top_bar_nav_dropdown_bg_color').';}';
}	
	
if(get_option($dirname.'_top_bar_link_color')) {
	$custom_css .= '#top-bar-inner a {color: '.get_option($dirname.'_top_bar_link_color').';}';
}

if(get_option($dirname.'_top_bar_link_hover_color')) {
	$custom_css .= '#top-bar-inner a:hover, #top-nav.nav .menu li a:hover, #top-nav.nav .menu li:hover > a {color: '.get_option($dirname.'_top_bar_link_hover_color').' !important;}';
}
	
	
// Header

if(get_option($dirname.'_header_bg_color')) {
	$custom_css .= '#header {background-color: '.get_option($dirname.'_header_bg_color').';}';
}	

if(get_option($dirname.'_header_padding')) {
	$custom_css .= '#header {padding: '.get_option($dirname.'_header_padding').'px;}';
}


// Body Nav

if(get_option($dirname.'_body_nav_bg_color')) {
	$custom_css .= '#body-nav {background-color: '.get_option($dirname.'_body_nav_bg_color').';}';
}

if(get_option($dirname.'_body_nav_link_color')) {
	$custom_css .= '#body-nav.nav .menu li a {color: '.get_option($dirname.'_body_nav_link_color').';}';
}

if(get_option($dirname.'_body_nav_link_hover_color')) {
	$custom_css .= '#body-nav.nav .menu li a:hover, #body-nav.nav .menu li:hover > a {color: '.get_option($dirname.'_body_nav_link_hover_color').';}';
}
		
if(get_option($dirname.'_body_nav_padding')) {
	$custom_css .= '#body-nav {padding: '.get_option($dirname.'_body_nav_padding').'px;}';
}	


// Page Widths

$custom_css .= '@media only screen and (min-width: 1440px) {';
	if(get_option($dirname.'_page_width_1')) {
		$custom_css .= '#page-wrapper, #top-bar-inner {width: '.get_option($dirname.'_page_width_1').'px !important;}';
	}	
$custom_css .= '}';		
$custom_css .= '@media only screen and (min-width: 1200px) and (max-width: 1439px) {';
	if(get_option($dirname.'_page_width_2')) {
		$custom_css .= '#page-wrapper, #top-bar-inner {width: '.get_option($dirname.'_page_width_2').'px !important;}';
	}	
$custom_css .= '}';	
$custom_css .= '@media only screen and (min-width: 1025px) and (max-width: 1199px) {';
	if(get_option($dirname.'_page_width_3')) {
		$custom_css .= '#page-wrapper, #top-bar-inner {width: '.get_option($dirname.'_page_width_3').'px !important;}';
	}	
$custom_css .= '}';
$custom_css .= '@media only screen and (min-width: 960px) and (max-width: 1024px) {';
	if(get_option($dirname.'_page_width_4')) {
		$custom_css .= '#page-wrapper, #top-bar-inner {width: '.get_option($dirname.'_page_width_4').'px !important;}';
	}	
$custom_css .= '}';
$custom_css .= '@media only screen and (min-width: 768px) and (max-width: 959px) {';
	if(get_option($dirname.'_page_width_5')) {
		$custom_css .= '#page-wrapper, #top-bar-inner {width: '.get_option($dirname.'_page_width_5').'px !important;}';
	}		
$custom_css .= '}';


// Primary Content Widths

$custom_css .= '@media only screen and (min-width: 1440px) {';
if(get_option($dirname.'_content_width_1')) {
	$custom_css .= '#content {width: '.get_option($dirname.'_content_width_1').'px !important;}';
}	
$custom_css .= '}';	
$custom_css .= '@media only screen and (min-width: 1200px) and (max-width: 1439px) {';
	if(get_option($dirname.'_content_width_2')) {
		$custom_css .= '#content {width: '.get_option($dirname.'_content_width_2').'px !important;}';
	}	
$custom_css .= '}';	
$custom_css .= '@media only screen and (min-width: 1025px) and (max-width: 1199px) {';
	if(get_option($dirname.'_content_width_3')) {
		$custom_css .= '#content {width: '.get_option($dirname.'_content_width_3').'px !important;}';
	}	
$custom_css .= '}';
$custom_css .= '@media only screen and (min-width: 960px) and (max-width: 1024px) {';
	if(get_option($dirname.'_content_width_4')) {
		$custom_css .= '#content {width: '.get_option($dirname.'_content_width_4').'px !important;}';
	}	
$custom_css .= '}';
$custom_css .= '@media only screen and (min-width: 768px) and (max-width: 959px) {';
	if(get_option($dirname.'_content_width_5')) {
		$custom_css .= '#content {width: '.get_option($dirname.'_content_width_5').'px !important;}';
	}		
$custom_css .= '}';


// Sidebar Widths

$custom_css .= '@media only screen and (min-width: 960px) {';
	if(get_option($dirname.'_sidebar_width_1')) {
		$custom_css .= '#sidebar {width: '.get_option($dirname.'_sidebar_width_1').'px !important;}';
	}	
$custom_css .= '}';			
$custom_css .= '@media only screen and (min-width: 768px) and (max-width: 959px) {';
	if(get_option($dirname.'_sidebar_width_2')) {
		$custom_css .= '#sidebar {width: '.get_option($dirname.'_sidebar_width_2').'px !important;}';
	}	
$custom_css .= '}';


// Custom Styling

if(get_option($dirname.'_custom_css')) {
	$custom_css .= stripslashes(get_option($dirname.'_custom_css'));
}

if(!empty($custom_css)) { echo '<style>'.$custom_css.'</style>'; }

?>