<?php 

if (!class_exists('gp_user_rating')) {

    class gp_user_rating {
    
        public $current_rating;
        public $current_position;
        public $count;

        function __construct() {

			if (is_single()) {
				$this->retrieve_values();
			}
			
			add_action('wp_ajax_gp_rating', array(&$this, 'sync_rating'));
			add_action('wp_ajax_nopriv_gp_rating', array(&$this, 'sync_rating'));

        }
		
        private function retrieve_values() {
        
            $current_rating = get_post_meta(get_the_ID(), 'current_rating', true);
            if (!$current_rating) {
                $current_rating = '0';
            }
            $this->current_rating = $current_rating;

            $current_position = get_post_meta(get_the_ID(), 'current_position', true);
            if (!$current_position) {
                $current_position = 0;
            }
            $this->current_position = $current_position;

            $count = get_post_meta(get_the_ID(), 'ratings_count', true);
            if (!$count) {
                $count = 0;
            }
            $this->count = $count;

        }

        public function sync_rating() {
        	global $gp_settings, $dirname;
        	
            // Sync scores
            $position = (int)$_POST['rating_position'];
            $post_id = (int)$_POST['post_id'];

            // Current scores
            $current_position = (int)get_post_meta($post_id, 'current_position', true);
            if (!$current_position) {
                $current_position = 0;
            }
            $current_rating = (int)get_post_meta($post_id, 'current_rating', true);
            if (!$current_rating) {
                $current_rating = 0;
            }
            $count = (int)get_post_meta($post_id, 'ratings_count', true);
            if (!$count) {
                $count = 0;
            }

			// Star Number
			if(get_post_meta($post_id, '_'.$dirname.'_star_number', true) && get_post_meta($post_id, '_'.$dirname.'_star_number', true) != 'Default') {
				$gp_settings['star_number'] = get_post_meta($post_id, '_'.$dirname.'_star_number', true);
			} else {
				$gp_settings['star_number'] = get_option($dirname.'_star_number');
			}

            // New score
            $new_position = ($current_position * $count + $position) / ($count + 1);
            $new_count = $count + 1;
            $new_rating = floor((((($new_position / (19.6 * $gp_settings['star_number']) * 100) * $gp_settings['star_number']) / 100) * 10)) / 10;

            // Update scores
            update_post_meta($post_id, 'current_position', $new_position, get_post_meta($post_id, 'current_position', true));
            update_post_meta($post_id, 'current_rating', $new_rating, get_post_meta($post_id, 'current_rating', true));
            update_post_meta($post_id, 'ratings_count', $new_count, get_post_meta($post_id, 'ratings_count', true));
            exit;
            
        }
    }
}

new gp_user_rating();